***************************************************************************
*                                                                         *
*         rwsystem.for                                                    *
*                                                                         *
*     -  LINUX / VMS / UNIX / DOS specific routines                       *
*     -  to switch, set appropriate value for 'iunix' in block data_unix  *
*                                                                         *
*        updated  03/95 : VMS                                             *
*        updated  04/95 : max 96chars in name_unix                        *
*        correct for dos=vms in byte handling (0=2)                       *
*        updated  11/95 : LINUX                                           *
*                                                                         *
***************************************************************************
c
c______________________________________________________________________
c
      block data data_unix
c
c   set the current flag LINUX / VMS / UNIX / DOS :   3 / 2 / 1 / 0
c______________________________________________________________________
c
      common /unix_dos/ iunix
c
c   version *************************************
c
#ifdef MAKE_DOS
      data   iunix  / 0 /
#elif defined(MAKE_UNIX)
      data   iunix  / 1 /
#elif defined(MAKE_VMS)
      data   iunix  / 2 /
#elif defined(MAKE_LINUX)
      data   iunix  / 3 /
#endif
      end
c______________________________________________________________________
c
      integer*4 function iflag_system (idummy) 
c
c______________________________________________________________________
c
      common /unix_dos/  iunix
c
      data init /0/
c
      if (init.eq.0)   then
         init = 1
         if (iunix.eq.0) then
            write (*,'('' --- DOS  detected '')')
         elseif (iunix.eq.1)   then
            write (*,'('' --- UNIX detected '')')
         elseif (iunix.eq.2)   then
            write (*,'('' --- VMS  detected '')')
         elseif (iunix.eq.3)   then
            write (*,'('' --- LINUX  detected '')')
         endif
      endif
c
      iflag_system = iunix
      end
c______________________________________________________________________
c
      logical function   unix_on (dummy)
c
c______________________________________________________________________
c
      common /unix_dos/  iunix
      if (iunix.eq.1)   then
         unix_on = .true.
      else
         unix_on = .false.
      endif
      end
c______________________________________________________________________
c
      subroutine unix_filename (filename,filename_unix)
c
c  replace  \  by '/' if unix is selected
c  only first 96 chars of filename are copied ! 
c______________________________________________________________________
c
      common /unix_dos/  iunix
      character filename*(*)
      character filename_unix*96,backsl*1,backsl_unix*1,char*1
      data      backsl, backsl_unix / '\\', '/' /
c
      filename_unix = ' '
      nc_in = len (filename)
      nc_ux = len (filename_unix)
      nc    = min (nc_in,nc_ux)	
      do i = 1,  nc
        char = filename(i:i)
clinux      if (iunix.eq.1)    then
      if (iunix.eq.1 .or.iunix.eq.3)    then
           if (char.eq.backsl)  char = backsl_unix
        endif
        filename_unix(i:i) = char
      enddo
      end
c______________________________________________________________________
c
      character*96 function name_unix (name)
c
c______________________________________________________________________
c
      common /unix_dos/  iunix
      character name*(*)
      character name_new*96
c
      call unix_filename(name,name_new)
c
      name_unix = name_new
      end
c______________________________________________________________________
c
      subroutine unix_cyclic_2 (in_2,nbyte,iou_2)
c
c   perform cyclic rotation for nbyte bytes - for UNIX, else keep  for integer*2
c   !! any zeroing of iou_2 has to be done before calling (if nbyte.lt.2)
c______________________________________________________________________
c
      common /unix_dos/  iunix
      character*1 in_2(2),iou_2(2)
c
      if (iunix.eq.1)   then
         do  i = 1, nbyte
           iou_2(2-i+1) = in_2(i)
         enddo
      else
         do  i = 1, nbyte
           iou_2(i) = in_2(i)
         enddo
      endif
      end
c______________________________________________________________________
c
      subroutine unix_cyclic_4 (in_4,nbyte,iou_4)
c
c   perform cyclic rotation for nbyte bytes - for UNIX, else keep  for integer*2
c   !! any zeroing of iou_4 has to be done before calling (if nbyte.lt.4)
c______________________________________________________________________
c
      common /unix_dos/  iunix
      character*1 in_4(4),iou_4(4)
c
      if (iunix.eq.1)   then
         do  i = 1, nbyte
           iou_4(4-i+1) = in_4(i)
         enddo
      else
         do  i = 1, nbyte
           iou_4(i) = in_4(i)
         enddo
      endif
      end
