c_______________________________________________________________________
c
c      program soff
c
c  read the snmp-data files & make first offline analysis
c  for 1995/1996/1997/1998
c
c_______________________________________________________________________
c
c  program is DOS/UNIX/VMS - compatible
c       (set systemflag in rwsystem.f,
c        use rwut_dos.f,*_uni.f,*_uni.f for dos/unix/vms)
c
c    'csftn'   = only for salford ftn77 (dos)
c    'cxftn'   = alternatively for unix ftn77
c    'clinux'  = extra's for linux 
c    'cdb'     - tag for detailed debugging
c
c  file blocklength for VMS (& trailing bytes) enforce use of tag=0
c  as indicator of 'logical eofdata' for VMS-files, i.e. don't use tag=0 !!
c
c  input files
c
c       1.   data-file
c                         ( multiple input files by:  'fname.*',
c                           expecting: fname.001, fanme.002 ... fname.n )
c
c       2.   "chmap.inp" - camac setup table, describing the correspondence
c                          between the maximal 10 snmp-blocks * 16 inputs
c                          and the logical channel names:
c                        1995     1 ...   80 for the "1pe" branch
c                              1001 ... 1080 for the "2pe" branch
c
c                        1996:    1 ...   86 = AMANDA-B
c                              1001 ... 1080 = AMANDA-A                         
c
c       3.   "chqual.inp" -  quality flag for all 160 chans: 1/0/-1 for
c                              ok/dead/bad
c                            ---. stored as ih = 10(1..80) + 11(1001..1080)
c
c       4.   "chuse.inp"  - channels, for which histos to be done
c
c   new: -  opt 'stat' for all nhit (arr,nhi-dt...)   02/04/95
c        -  "array" for all & good PMTs
c        -  option "winter" for minimal dialogeee
c           & rintout to listfile
c        -  filespec extended to 96 chars max. (e.g. name_unix), p.mock 3/95	
c        -  
c
c   1996 changes:
c        -  primary data format
c        -  itime_sn-offset = 0
c        - allow (&check) for non-consequtive files
c
c   1997 changes:
c        - relax nb. of input channesl from chuse.inp/chqual.inp
c            all non-quoted chans (i.e. compiled) are set
c            to qual=0, use=o
c        - .....
c
c  to be done ...:
c                   - read the configuration file (*.log)
c                        to replace 'setup.inc'
c
c                     ... a lot more ...
c
c  in case of trouble & comments to:   wischnew@ifh.de (ralf wischnewski)
c
c
c
c  Version:   04/20/95:   1.43
c
cc      block data iversion
cc      common /vers/    ivers(4)
cc      data             ivers /   1 , 4, 3 , 0 /
c
c   zeuthen - test measurements  09/95
c   labeled:   czeu
c
c   pole om-measurements: adapt linux   11/95
c
c
c  Version:   11/01/97:   2.10
c
c      block data iversion
c      common /vers/    ivers(4)
c      data             ivers /   2 , 1, 0 , 0 /
c  Version:   25/03/99:   2.11
c
      block data iversion
      common /vers/    ivers(4)
      data             ivers /   2 , 1, 1 , 0 /
      end
c
c
c_______________________________________________________________________
c
      program soff
c
c
clinux
      call imi_block_data

      call init_hb
      call init (ier)
      if (ier.ne.0)   go to  999
      call ihbk
c
      call evt_loop
c
      call finish
c
  999 end
c
c_______________________________________________________________________
c
      subroutine init (ier)
c
c  set filenames, operation mode...
c
c    ier (out)   - 0=ok
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      common /vers/      ivers(4)
      parameter          (nfiles_max=999)
      common /inpfil/    nfiles_inp,ifile_curr,fname_inp(nfiles_max)
      character          fname_inp*96
      common /ncons/     ifile_ncons,ifile_ncons_blocks,
     +                   il_ifile_ncons_lo(999),il_ifile_ncons_up(999)

      integer            idate(2),ihour(2)
      character          name*96,name_unix*96,date*8,hour*8,
     +                   ibyte_char*1,ch_outdir_sys(4)*10,ch_outdir*10,
     +                   fname_lst*96
      logical            yes, jwinter96
      equivalence (ibyte_char,ibyte)

      data           ch_outdir_sys / 'out\\', 'out/','[.out]','out\\' /
c
c
      ier        = 0
      lun_in     = 10
      lun_hbk    = 11
      lun_hbksat = 12
      lun_lst    = 13
      ch_outdir  = ch_outdir_sys (iflag_system(idummy)+1)

      jwinter96 = .true.
      jwinter96 = .false.
c
      call init_inpfil_new (ier)
      if (ier.ne.0)    go to   999
c96      call wait_press_prompt ('ret')
c
c set 1995 / 1996
c
      if (jwinter96)  then
         i = 1
      else   
   11    call getint 
     +   ('===> data with 1996 SNMP-Modules ? (1=yes/0=no)$',i)
         if (i.ne.0.and.i.ne.1)   go to   11
      endif
      iflag_snmp96 = i
c
c  set high rate mode
c
      if (jwinter96)  then
         iflag_highrate = 0
      else   
   21    call getint ('===> normal or high-rate-mode (0/16/256)$',i)
         if (i.eq.0)   then
            iflag_highrate = 0
         elseif (i.eq.16 .or. i.eq.256)   then
            iflag_highrate = i
         else
            go to    21
         endif
      endif
c
c
c
      if (.not.jwinter)   then
         call mygetlog ('===> hbook output file (y/n)$',yes)
   31    if (yes)   then
            iflag_hbk = 1
            name = name_run
cc            call getcha ('===> Give hbook file (no ext):$',name)
            call sfb (name,ib)
            call sfb (ch_outdir,ib1)
            fname_hbk = ch_outdir(:ib1)//name(:ib)//'.hbk'
c   1024 words 
cpole            open(lun_hbk,file=name_unix(fname_hbk),access='direct',
cpole     +      recl=4096,form='unformatted',status='new',err=930)
c???in hbk_out         call hropen(lun_hbk,'1',name_unix(fname_hbk),'N',1024,istat)
         else
            iflag_hbk = 0
         endif
c
c-- run flags ...
c
         call mygetlog ('===> full debugging (y/n)?$',jdebug)
         call mygetlog ('===> stop at suspect data (y/n)?$',jsuspect)
      else
c
ccc      call mygetlog ('===> hbook output file (y/n)$',yes)
ccc   31 if (yes)   then
c99         iflag_hbk = 1
         iflag_hbk = 0
ccc         call getcha ('===> Give hbook file (no ext):$',name)
         name = name_run
         call sfb (name,ib)
         call sfb (ch_outdir,ib1)
         fname_hbk = ch_outdir(:ib1)//name(:ib)//'.hbk'
c   1024 words 
cpole         open(lun_hbk,file=name_unix(fname_hbk),access='direct',
cpole     +      recl=4096,form='unformatted',status='new',err=930)
cin hbk_out         call hropen(lun_hbk,'hbk',name_unix(fname_hbk),'N',1024,istat)
c
c-- run flags ...
c


         jdebug   = .false.
c98         jdebug = .true.

c98         jsuspect = .false.
         jsuspect = .true.
c
c-- force listing, set sat-hbk file name
c
         jlist = .true.
         name = name_run
         call sfb (name,ib)
         call sfb (ch_outdir,ib1)
         fname_hbksat = ch_outdir(:ib1)//name(:ib)//'.hrs'
      endif
czeu
      if (jlist)  then
         name = name_run
         call sfb (name,ib)
         call sfb (ch_outdir,ib1)
         fname_lst    = ch_outdir(:ib1)//name(:ib)//'.lrs'
         open(lun_lst,file=name_unix(fname_lst),
     +        form='formatted',status='new',err=940)
    
  
      endif
czeu
c
c --  store on "status" histogram...
c
      call datimh (idate,ihour)
      call uhtoc (idate,4,date,8)
      call uhtoc (ihour,4,hour,8)
      ih_stat = 9
      do  i = 1, 8
        ibyte_char = date(i:i)
        call hfill (ih_stat,float(i),0.,float(ibyte))
      enddo
      do  i = 1, 8
        ibyte_char = hour(i:i)
        call hfill (ih_stat,float(i+8),0.,float(ibyte))
      enddo
      do  i = 1, 3
        call hfill (ih_stat,float(20+i),0.,float(ivers(i)))
      enddo
c
      if (jlist)   nl=2
      do i = 1, nl
        l = 6
        if (i.gt.1) l = lun_lst
cc        write (*,1000)  date, hour
        write (l,1000)  date, hour
 1000   format (/' --- SOFF Run --- '/
     +            '     Date: ',a8 / '    Time: ',a8)
cc        write (*,1100)  (ivers(j),j=1,3)
        write (l,1100)  (ivers(j),j=1,3)
 1100   format (/'     Program Version:',i2,'.',i2,'/',i2)

cc        write (*,1200)  name_run,nfiles_inp
        write (l,1200)  name_run,nfiles_inp
 1200   format (/'     Run Name       :',a72
     +          /'                     with',i4,' files'/)
      enddo
c
c  the hardware setup
c
      call set_off_channel
c
c  selection of channels used-for analysis and channel quality 
c
      call set_useana_channel

      call set_qual_channel

c
c   just print the missing files...  (list file only here opened!)
c
       if (jlist)   then
          do  i = 1, ifile_ncons_blocks
            il = il_ifile_ncons_lo(i) 
            iu = il_ifile_ncons_up(i) 
            if (i.eq.1) write (lun_lst,'(/60(1H*)/)')
            write (lun_lst,
     +       '('' *** missing files: '',i4,''  to'',i4)') il,iu
          enddo
          if (ifile_ncons.ne.0)  then
             write (lun_lst,
     +     '('' *** tot.nb of non-consequtive files='',i6)')ifile_ncons 
             write (lun_lst,'(/60(1H*)//)')
          endif   
       endif   
c
      go to 999
c
  930 write (*,'('' *** sorry, error opening hbook file:'',a72)')
     +   name_unix(fname_hbk)
      write (*,'('' ... delete if file already exists'')')
ccc      if (.not.jwinter)   go to 31
      go to 990
  940 write (*,'('' *** sorry, error opening list file:'',a72)')
     +   name_unix(fname_lst)
ccc      write (*,'('' ... delete if file already exists'')')
  990 ier = 1
c
  999 if (jlist) write (lun_lst,'('' '')')
      end
c
c_______________________________________________________________________
c
      subroutine init_inpfil_new (ier)
c
c  new:  get & check for all input data files
c        decide for run-period in steps of 25 files
c
c   ier (out)   -  0=ok
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      parameter          (nfiles_max=999)
      common /inpfil/    nfiles_inp,ifile_curr,fname_inp(nfiles_max)
      character          fname_inp*96
      common /ncons/     ifile_ncons,ifile_ncons_blocks,
     +                   il_ifile_ncons_lo(999),il_ifile_ncons_up(999)

      character          name*96,name1*96,name2*100,
     +                   name_unix*96,char3*3
      character*10 cdirect,cformatted,cunformatted,csequential
      logical            jexist, yes
c
c
      ier        = 0
c
   20 nfiles_inp = 0
      ifile_curr = 0
      iperiod    = 0
      ifile_ncons = 0
      ifile_ncons_lo = 0
      ifile_ncons_up = 0
      ifile_ncons_blocks = 0
      name = ' '
      call getcha ('===> Give data file ([*]sm???.*):$',name)
c
      call sfb (name,ib)
      iwild = 0
      if (name(ib:ib).eq.'#')   then        !  '#' is for only consequtive  files
         ii = ib - 1
         if (name(ii:ii).eq.'.')  then
            idot_name = ib - 2
            iwild = 1
         else
            go to 20
         endif
      elseif (name(ib:ib).eq.'*')   then
         ii = ib - 1
         if (name(ii:ii).eq.'.')  then
            idot_name = ib - 2
            iwild = 2
         else
            go to 20
         endif         
      else
         go to 22       
      endif 
c
   22 if (iwild.eq.0)   then
         Inquire (file=name_unix(name),exist=jexist,recl=irecl,
     +        direct=cdirect,formatted=cformatted,
     +        unformatted=cunformatted,sequential=csequential)
         if (jexist)   then
            nfiles_inp = nfiles_inp + 1
            call sfb (name,ib)
            fname_inp(nfiles_inp) = name(:ib)
            write (*,'(i4,''. file found: '',a72)') nfiles_inp,name
         else
            write (*,'('' file not found: '',a72)') name
ccc            go to   100
            go to   20
         endif
      else
         irecl_lo = -1
         irecl_up = -1
         name1 = name(:idot_name)
         name2 = ' '
         do  i = 1, nfiles_max
           call sfb (name1,ib)
           if (i.lt.10)   then
              char3 = '000'
              write (char3,'(i1)') i
              name2 = name1(:ib) // '.00' // char3(1:1)
           elseif (i.lt.100)   then
              write (char3,'(i2)') i
              name2 = name1(:ib) // '.0' // char3(1:2)
           elseif (i.lt.1000)   then
              write (char3,'(i3)') i
              name2 = name1(:ib) // '.' // char3(1:3)
           else
              name2 = ' '
           endif
           Inquire (file=name_unix(name2),exist=jexist,recl=irecl,
     +        direct=cdirect,formatted=cformatted,
     +        unformatted=cunformatted,sequential=csequential)
c
           if (jexist)   then
              nfiles_inp = nfiles_inp + 1
              if (ifile_ncons_lo.ne.0)  then         !  end missing file region
                 ifile_ncons_up = i-1                 
                 ifile_ncons = ifile_ncons + 
     +                        (ifile_ncons_up-ifile_ncons_lo+1)
                 ifile_ncons_blocks = ifile_ncons_blocks + 1
                 il_ifile_ncons_lo(ifile_ncons_blocks) = ifile_ncons_lo
                 il_ifile_ncons_up(ifile_ncons_blocks) = ifile_ncons_up
                 write (*,
     +              '('' *** missing files: '',i4,''  to'',i4)') 
     +              ifile_ncons_lo,ifile_ncons_up
ccc                 if (jlist)  write (lun_lst,
ccc     +              '('' *** missing files: '',i4,''  to'',i4)') 
ccc     +              ifile_ncons_lo,ifile_ncons_up
                 ifile_ncons_lo = 0
              endif
              call sfb (name2,ib)
              fname_inp(nfiles_inp) = name2(:ib)
              write (*,'(i4,''. file found: '',a50)') nfiles_inp,name2
           elseif (iwild.eq.0 .or. iwild.eq.1)   then        !  successive files only
              if (nfiles_inp.eq.0)   then
                 write (*,'('' file not found: '',a50)') name2
ccc                 go to   100
                 go to   20
              endif
              go to   50
           elseif (iwild.eq.2)   then              !  allow for non-consequtive files 
              if (i.eq.nfiles_max)   then
                 if (nfiles_inp.eq.0)   then
                    write (*,'('' no files found: '',a50)') name2
                    go to   20
                 else
                    go to   50
                 endif
              else
                 if (ifile_ncons_lo.eq.0)  then   ! start missing file region
                    ifile_ncons_lo = i 
                    ifile_ncons_up = 0                 
                 endif
                 go to   25                
              endif
           endif
   25    enddo
      endif
c
c  decide for run-period for large runs
c
c96
   50 mx_per = 25
      if (ifile_ncons.gt.0)   then
         write (*,'('' nb of non-consequtive files='',i6)') ifile_ncons 
ccc         if (jlist)  write 
ccc     +    (lun_lst,'('' nb of non-consequtive files='',i6)') ifile_ncons 
      endif   
      if (nfiles_inp.gt.mx_per)   then
   51    write (*,
     +   '('' ... there are too may files for this run'',1x,
     +     '' to be analyzed in a single pass ...''/
     +     ''     Analysis will be done in separate periods with'',
     +     i5,'' files each'')')   mx_per
   52    call getint
     +(' ===> please select a run period (1=file001-025,2=026-050,...)$'
     + ,iperiod)
         if (iperiod.lt.1 .or. iperiod.gt.25)   go to 51
         if_first = (iperiod-1)*mx_per + 1
         if (if_first.gt.nfiles_inp)   go to   52
         if_last  = if_first + mx_per - 1
         if (if_last.gt.nfiles_inp)  if_last = nfiles_inp
         nf_act   = if_last-if_first + 1
         write(*,
     +   '('' Run Period selected ='',i4,'' with'',i4,'' files'')')
     +   iperiod,nf_act
         write(*,'('' ... first file:'',a72)') fname_inp(if_first)
         write(*,'('' ... last  file:'',a72)') fname_inp(if_last)
         call mygetlog (' ===> acctepted (y/n) ?$',yes)
         if (.not.yes)   go to  52
c    accepted
         do i = 1, nf_act
           fname_inp(i) = fname_inp(if_first+i-1)
         enddo
         nfiles_inp = nf_act
         if (jlist)  then
            write(lun_lst,
     +      '('' Run Period selected ='',i4,'' with'',i4,'' files'')')
     +      iperiod,nfiles_inp
            write(lun_lst,'('' ... first file:'',a72)') fname_inp(1)
            write(lun_lst,
     +      '('' ... last  file:'',a72)') fname_inp(nfiles_inp)
         endif
      endif
c
      name1 = ' '
      if (jwinter)   then
         call getcha
ccc     +   (' ===> name of output files (for .hbk/.lrs & hrs-files):$',
     +   (' ===> Give name of output files (e.g. SM001_1_tst):$',
     +    name1)
         call sfb (name1,ib)
         name_run=name1(:ib)
      else
         call getcha ('===> Give name of run (out-files):$',name1)
         call sfb (name1,ib)
         name_run = name1(:ib)
      endif
c
  100 if (nfiles_inp.eq.0)   ier = 1
      if (iperiod.ne.0)
     +write (*,'('' total nb. of input files found:'',i4)') nfiles_inp
c
      end
c
c_______________________________________________________________________
c
      subroutine open_nextfile (iend)
c
c     open next input file
c
c     iend (out)    = 0 ok.,   +1 no more files, -1 error opening
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      parameter          (nfiles_max=999)
      common /inpfil/    nfiles_inp,ifile_curr,fname_inp(nfiles_max)
      character          fname_inp*96
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off

      character          name_unix*96,name80*80,name*60
c
c
      iend       = 0
      if (ifile_curr.ge.nfiles_inp)  then
         iend = 1
         write (*,1100) itime_sn
         if (jlist)  write (lun_lst,1100) itime_sn
 1100    format
     +   (/' ... no more input files... / Last SN-Time(0.5sec)',i10)
         go to  999
      endif
      ifile_curr = ifile_curr + 1
c
      if (iflag_system(idum).eq.2)   then
c  vms:  open for nwords, inquire with nbyte  !!!
         lrec_byte_in = 512
         lrec_open    = lrec_byte_in/4
cdb         print *,' vms: lrec_open (words)=',lrec_open
      else
         lrec_byte_in = 1
         lrec_open    = lrec_byte_in
      endif
c
      name80 = ' '
      name80 = name_unix (fname_inp(ifile_curr))
      open (lun_in,file=name_unix(fname_inp(ifile_curr)),
     +     form='unformatted',
     +      status='OLD',access='direct',recl=lrec_open)
c                ,err=920)
c
      call sfb (name80,ip)
      name = ' '
cc??      name = name80(1:ip)
      name = fname_inp(ifile_curr)
      write (*,
     +'(/i4,''. file opened: '',a60/45x,''last SN_time=(0.5sec)'',i8)')
     +      ifile_curr,name,itime_sn
      if (jlist)  write (lun_lst,
     +'(/i4,''. file opened: '',a60/45x,''last Sn_time(0.5sec)='',i8)')
     +      ifile_curr,name,itime_sn
      go to 999
c
  920 iend = -1
      write (*,9200)  name80
      if (jlist)  write (lun_lst,9200)  name80
 9200 format (' *** sorry, error opening data file:',a80)
c
  999 end
c
c_______________________________________________________________________
c
      subroutine init_hb
c
c_______________________________________________________________________
c
      parameter       (ihmax=20000000)
c97      parameter       (ihmax=7000000)
      common / pawc / h(ihmax+1000)

      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96


c
      call hlimit (ihmax)
c97      call houtpu (6)
c97      call hermes (6)
      call houtpu (lun_lst)          !  though not yet opened
      call hermes (lun_lst)
c
      call ihbk_gen
c
      end
c
c_______________________________________________________________________
c
      subroutine ihbk
c
c  steer histo booking...
c_______________________________________________________________________
c
c
      call ihbk_snmp
c
      end
c_______________________________________________________________________
c
      subroutine ihbk_gen
c
c_______________________________________________________________________
c
#include "setup.inc"
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
c
c
c -- GENERAL:  tag, quality, status (date,time,version)
c
      if (j_tag)   then
         call hbook1 (ih_tag,'All Tags',50,0.,50.,0.)
      endif
      call hbook1 (9,'Status info...',50,0.,50.,0.)
c96      call hbook1 (ih_qual  ,'Quality Branch 1',80,1.,81.,0.)
c96      call hbook1 (ih_qual+1,'Quality Branch 2',80,1.,81.,0.)
      call hbook1 (ih_qual  ,'Quality AM-B',86,1.,87.,0.)
      call hbook1 (ih_qual+1,'Quality AM-A',80,1.,81.,0.)
c
      end
c_______________________________________________________________________
c
      subroutine ihbk_snmp
c
c_______________________________________________________________________
c
#include "setup.inc"
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
c
      character   ch_chan*5,title*60,ch3*3,ch4*4
      data        ch_chan /'Chan '/
c
c  two thresholds...
c
ccc      nch     = 2 * nom_str*nstring
ccc      nsb_mod = 2*nstring
cirvine !!!error !!!!!
      nch     = nchan_order
cirivine      nch = 160
czeu      nsb_mod = 20
c96 preliminary  !!!!!!!! (---> setup.inc !!)
      nsb_mod = 2*((nch-1)/16 + 1)
c
c -- Supernovae:
c       code     = 1 000000 + ichan
c96c                = 1 002000   all chans, branch 1
c96c                = 1 003000   all chans, branch 2
c                = 1 002000   all chans, AM-B
c                = 1 003000   all chans, AM-A
c       time     = 1 100000   all sub_modules
c       time     = 1 100000 + isb_mod separate sub_modules
c       timediff = 1 200000 + isb_mod
c
      if (.not.j_sn_prim)   then
         j_sn_cou = .false.
         j_sn_time = .false.
         j_sn_tdiff = .false.
      else
         if (j_sn_cou)   then
            do  i = 1, nch
              ichan = ichan_order(i)
              write (ch4,'(i4)')  ichan
              title = 'SN Nhit, '//ch_chan//ch4//', dt = 0.5sec'
              call sfb (title,ip)
              ih = ih_sn_cou_cha + ichan
              call hbook1 (ih,title(:ip),4096,0.,4096.,0.)
              call hidopt (ih,'stat')
            enddo
            xlo = 0.
            xup = 80*4096.
            ih  = ih_sn_cou_cha+2000
            call hbook1 (ih,
c96     +       'SN Nhit - Array, Branch 1, dt = 0.5sec',4096,xlo,xup,0.)
     +       'SN Nhit - Array, AM-B, dt = 0.5sec',4096,xlo,xup,0.)
            call hidopt (ih,'stat')
            ih  = ih_sn_cou_cha+3000
            call hbook1 (ih,
c96     +       'SN Nhit - Array, Branch 2, dt = 0.5sec',4096,xlo,xup,0.)
     +       'SN Nhit - Array, AM-A, dt = 0.5sec',4096,xlo,xup,0.)
            call hidopt (ih,'stat')
         endif
         if (j_sn_time)   then
            tup_sn_time = 100000.
            nc_sn_time  = tup_sn_time / 1000.
            call hbook1 (ih_sn_time,
     +      'SN time counts, all Sb_mod',nc_sn_time,0.,tup_sn_time,0.)
            do i = 1, nsb_mod
              write (ch3,'(i3)')  i
              title = 'SN time counts, Sb-mod '//ch3
              call hbook1
     +        (ih_sn_time+i,title,nc_sn_time,0.,tup_sn_time,0.)
            enddo
         endif
         if (j_sn_tdiff)   then
            do i = 1, nsb_mod
              write (ch3,'(i3)')  i
              title = 'SN timediff, Sb-mod '//ch3
              call hbook1 (ih_sn_tdiff+i,title,110,-10.,100.,0.)
            enddo
         endif
      endif
c
c -- Monopoles:
c       code     = 2 000000 + ichan (or:  + 100*istr + ichan)
c       time     = 2 100000   all sub_modules
c       time     = 2 100000 + isb_mod separate sub_modules
c       timediff = 2 200000 + isb_mod
c
      if (j_mp_prim)   then
         do  i = 1, nch
           ichan = ichan_order(i)
           write (ch4,'(i4)')  ichan
           title = 'MP Nhit, '//ch_chan//ch4
           call sfb (title,ip)
           ih = ih_mp_cou_cha + ichan
           call hbook1 (ih,title(:ip),16,0.,16.,0.)
         enddo
         call hbook1 (ih_mp_time,'MP time',1700,0.,1.7e7,0.)
         do i = 1, nsb_mod
           write (ch3,'(i3)')  i
           title = 'MP time, Sb-mod '//ch3
           call hbook1 (ih_mp_time+i,title,1700,0.,1.7e7,0.)
         enddo
         do i = 1, nsb_mod
           write (ch3,'(i3)')  i
           title = 'MP timediff, Sb-mod '//ch3
           call hbook1 (ih_mp_tdiff+i,title,210,-10.,200.,0.)
         enddo
      endif
c
      end
c
c_______________________________________________________________________
c
      subroutine finish
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
ccc      write (*,
ccc     + '('' # blocks/ bytes read:'',2i10)') nblock_in,nbyte_in
c
ccc      call wait_press_prompt ('ret')
c
c
      call fin_rates
c
      if (.not.jwinter)   then
         call hidopt (1,'nphi')
         call hidopt (1,'npch')
         call hprint (1)
      endif
      call prt_sum
c
      call hbk_out_monop              ! minimal monopole-histos
      call hbk_out                    ! full hbook-output
c
      if (jwinter)  then
         call hbk_sat
      endif
c
      end
c______________________________________________________________________
c
      subroutine prt_sum
c
c   short summary on tags & fifo erros
c______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      parameter          (nfiles_max=999)
      common /inpfil/    nfiles_inp,ifile_curr,fname_inp(nfiles_max)
      character          fname_inp*96
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off
c
c
      ih = 1
      ntag10 = hx(ih,10.)
      ntag11 = hx(ih,11.)
      ntag12 = hx(ih,12.)
      ntag20 = hx(ih,20.)
      ntag21 = hx(ih,21.)
c    header
      ntag30 = hx(ih,30.) 
c
      write (*,1000) ifile_curr,nfiles_inp
      write (*,1010) float(itime_sn)/2.
      write (*,1100) ntag10,ntag11,ntag12,ntag20,ntag21,ntag30
      if (jlist)   then
       write (lun_lst,1000) ifile_curr,nfiles_inp
       write (lun_lst,1010) float(itime_sn)/2.
       write (lun_lst,1100) ntag10,ntag11,ntag12,ntag20,ntag21,ntag30
      endif
c
      if (ntag30.gt.0)   then
ccc         write (*,1300)
ccc         if (jlist) write (lun_lst,1300)
      endif
c
 1000 format (/
     +        ' ===>  Run finished after',i4,' files out of',i4,
     +        ' files selected')
 1010 format (' ===>  Number of seconds =',f10.1)
 1100 format (' ===>  Number of tags: '/
     +'     Tag10     Tag11     Tag12     Tag20     Tag21     Tag30'/
     +'  Supernov   Monopol      Time     Synch     Synch   eg.FIFO'/
     +'                                                  (ex. head)'/
     +'------------------------------------------------------------'/
     +  6i10 )
 1300 format (/
     + ' ************************************************'/
     + ' **** PLEASE, TRY TO CHANGE MONOPOLE SETTINGS ***'/
     + ' **** TO REDUCE  FIFO-OVERFLOW                ***'/
     + ' ************************************************'/   )
      end
c
c______________________________________________________________________
c
      subroutine hbk_out
c
c   output the normal "big" hbook file
c______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c
      character          name_unix*96
c
c
      if (iflag_hbk.ne.0)   then
         call hropen(lun_hbk,'hbk',name_unix(fname_hbk),'N',1024,istat)
ccc         call hrfile(lun_hbk,'hbk','N')
         call hrout(0,icycle,' ')
         call hrend('hbk')
         close (lun_hbk)
         write(*,'('' HBOOK output written to file:  '',a72)')fname_hbk
         if (jlist)   write (lun_lst,
     +           '('' HBOOK output written to file:  '',a72)')fname_hbk
      endif
      end
c______________________________________________________________________
c
      subroutine hbk_out_monop
c
c   output minimal monopole hbook file
c______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c
      integer       ih_all(10000)
      character*96  fname_hbk_mo, name_unix*96

c99  no monopole files!

      goto 999

      lun_hbk_mo = 39
      call sfb (fname_hbk,ip)
      fname_hbk_mo = fname_hbk(:ip)//'_mono'            
      call hropen
     + (lun_hbk_mo,'hbkmono',name_unix(fname_hbk_mo),'N',1024,istat)

      call hidall(ih_all,nih_all)
         
      do i = 1, nih_all
         ih = ih_all(i)
         if (ih/1000000.eq.2)   then        ! monopole tag
            call hrout(ih,icycle,' ')
         endif
      enddo
      call hrend('hbkmono')
      close (lun_hbk_mo)
      write(*,'('' HBOOK/monop written to file: '',a96)')fname_hbk_mo
      if (jlist)   write (lun_lst,
     +        '('' HBOOK/monop written to file: '',a96)')fname_hbk_mo
  999 end
c_______________________________________________________________________
c
      subroutine hbk_sat
c
c    output & compose the "satellite" hbook file
c
c       1. select appropriate histos from full-hbook sample
c       2. set for rates (array,channels)  resolution to 2 byte
c            (i.e. range = 1Hz ... 65535Hz ), not for qual-id's
c       3. supress the error bins, stored for all rates on full-hbook
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
#include "setup.inc"
c
czeu      parameter (mx_xent=200000)
      parameter (mx_xent=400000)
      real      xent(mx_xent)
      integer   ih_read(500),ih_out(500),idvmx0(500)
      character title*80,name_unix*96
      logical   hexist

      data ioffset / 10000000/,  vmx / 60000. /
      data idvmx0  / 9, 10, 11, 5001056, 5001078, 495*0 /
c
c
      ih_read(1) = 1
      ih_read(2) = 9
      ih_read(3) = 10
      ih_read(4) = 11
      ih_read(5) = 5012000
      ih_read(6) = 5013000
czeu      ih_read(7) = 5001056
czeu      ih_read(8) = 5001078
czeu      nh_r       = 8
      nh_r       = 6

c96tmp
c96zz      call hindex

ccc      do  i = 1, 160
czeu      do  i = 1, 80
      do  i = 1, nchan_order
c   selected chans exist only           
        ichan = ichan_order(i)
        if (ichan_useana_inv(ichan).le.0)   go to 200
c
ccc        ic   = i
ccc        if (i.gt.80) ic = 1000 +i - 80
c   variable channel names
        ic   = ichan
        nh_r = nh_r + 1
        ih_read(nh_r) = 5000000 + ic
c  add distribution
c96 tmp
c96        nh_r = nh_r + 1
c96        ih_read(nh_r) = 6000000 + ic
c96        ih_read(nh_r) = ih_sn_cou_cha + ic
  200 enddo
c
      nh_out = 0
      do i =1, nh_r
        ih     = ih_read(i)
        ihnew = ih + ioffset
        if (.not.hexist(ih))   then
           write (*,1100)  ih
           if (jlist) write (lun_lst,1100)  ih
 1100      format (' *** histogram not existing, id=',i9)
        else
           call hgive (ih,title,nx,xlo,xup,ny,ylo,yup,nwt,ialoc)
c96tmp
ccc           print *, ' ih, nx,xlo,xup=',ih,nx,xlo,xup
           if (nx.le.mx_xent)   then
c
c   avoid 'hcopy', for error-content supression
c
              vmxact = vmx
              do jj = 1, nh_r
                if (idvmx0(jj).eq.ih)  vmxact = 0.
              enddo
cdb
cdb              if (vmxact.eq.0.)print *,' .. vmx=0. found,ih=',ihnew
              call hbook1 (ihnew,title,nx,xlo,xup,vmxact)
              nh_out = nh_out + 1
              ih_out(nh_out) = ihnew
              do  j = 1, nx
                xent(j) = hi(ih,j)
              enddo
              call hpak (ihnew,xent)
           else
              write (*,1200) ih, nx
              if (jlist) write (lun_lst,1200) ih,nx
           endif
        endif
      enddo
 1200 format(' *** hbk_sat: too long histogram, ih,#bins =',i12,i10)
c
ccc      open(lun_hbksat,file=name_unix(fname_hbksat),access='direct',
ccc     +     recl=1024,form='unformatted',status='new')
ccc      call hrfile(lun_hbksat,'1','N')
      call hropen
     + (lun_hbksat,'hrs',name_unix(fname_hbksat),'N',1024,istat)
c
      do  i = 1, nh_out
        ih = ih_out(i)
        call hrout(ih,icycle,' ')
      enddo
c
      call hrend('hrs')
      write(*,'(/'' HBKSAT output written to file: '',a72)')fname_hbksat
      if (jlist)   write (lun_lst,
     +        '(/'' HBKSAT output written to file: '',a72)')fname_hbksat
      close (lun_hbksat)
      end
c
c_______________________________________________________________________
c
      subroutine evt_loop
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1
c
c
      nbyte_in_tot  = 0
      nblock_in_tot = 0
c
c  ... next file
c
    5 call open_nextfile (iendfile)
      if (iendfile.ne.0)       go to 900
c
      nbyte_in  = 0
      nblock_in = 0
c
c   ...next record
c
   10 call next_block (iend)
      if (iend.gt.0)   go to   5
      if (iend.lt.0)   go to 900
c
      nblock_in = nblock_in + 1
      if (itag.eq.10)    then
         call get_sn
      elseif (itag.eq.11)   then
         call get_mp
      elseif (itag.eq.12)   then
         call get_clock
      elseif (itag.eq.20.or.itag.eq.21)   then
ccc         call get_synch
      elseif (itag.eq.30)   then
         call get_message
      elseif (iflag_snmp96.ne.0.and.(itag.eq.14.or.itag.eq.15))   then   ! 1996
         call get_fifodump
      elseif (iflag_snmp96.ne.0.and.itag.eq.255)   then                  ! 1996
c         end-of-file
      elseif (iflag_snmp96.ne.0.and.itag.eq.111)   then
         call get_grb_111
      else                                           
         if (jdebug.or.jsuspect)
     +      write (*,'('' *** wrong tag, nblock, nbyte ='',3i12)')
     +      itag,nblock_in,nb_ch_data
         if (jlist)    
     +      write (lun_lst,'('' *** wrong tag, nblock, nbyte ='',3i12)')
     +      itag,nblock_in,nb_ch_data
         if (jsuspect) call wait_press_prompt ('esc')
      endif
c
      call an_block
c
      go to 10
c
  900 end
c
c_______________________________________________________________________
c
      subroutine next_block (iend)
c
c   read the next block  ......................
c
c     for VMS: find logical EOD, and skip trailing '0's, used to fill
c              up the last record in a VMS-file
c
c   iend (out)   -  .ne.0 - end of file found, >0 normal, <0 abnormal
c                           1 = normal eof, 2 = vms eof (itag=0 triggers)
c                          -1 = abnormal eof
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1
c
      character          char_in(8)*1,byte_in*1
csftn      integer            ichar_in(8)*1
      integer            i1_1_i4*4, i1_3_i4_mac*4
      equivalence       (ichar_in,char_in)
c
      itag = -1
      iend = 0
c
c   first, get the tag of next block ...
c
      do  i = 1, 4
c             so easy life would have been without that VMS-file structure !!
cc        read (lun_in,rec=nbyte_in+1,iostat=ios)  char_in(i)
        call read_next_byte (nbyte_in+1,ios,char_in(i))
        if (ios.ne.0)    then
           if (i.eq.1)   then
cdb              write (*,
cdb     +    '('' ... normal end-of-file (1):  # bytes read, iostat-flag=''
cdb     +        ,i9,i6)')  nbyte_in,ios
              iend = 1
           else
c      was too strong: case lt.4 extra bytes through vms-"filling" to 512 block!
ccc              print *,' ***  abnormal eof: ios,nbyte_in=',ios,nbyte_in
ccc              iend = -1
ccc              call wait_press_prompt ('ret')
cdb              write (*,
cdb     +    '('' ... normal end-of-file (2):  # bytes read, iostat-flag=''
cdb     +        ,i9,i6)')  nbyte_in,ios
                iend = 1
           endif
           go to 999
        endif
        nbyte_in = nbyte_in + 1
csftn        write (*,'(i7,3x,z2)') nbyte_in,ichar_in(i)
cxftn        write (*,'(i7,3x,z2)') nbyte_in, char_in(i)
      enddo
c
      itag       = i1_1_i4 (char_in(1))
      nb_ch_data = i1_3_i4_mac (char_in(2))
c
c   vms: empty last blockend... : use tag=0 as logical end-of-data
c
      if (iflag_system(idumm).eq.2)   then
         if (itag.eq.0)   then
            nbyte_in = nbyte_in - 4
            iend = 2
cdb            write (*,
cdb     +      '('' ... vms finds eof-data: itag='',i4
cdb     +      ,'' after nbyte_in='',i10)') itag,nbyte_in
         endif
      endif
c
c96tmp      if (jdebug.or.mod(nblock_in,10000).eq.0.and..not.jwinter)
      if (jdebug.or.mod(nblock_in,1000).eq.0)
     +    write (*,'('' block#, itag, length='',i7,i4,i5)')
     +    nblock_in+1,itag,nb_ch_data
c
      if (nb_ch_data.gt.mx_ch_data)   then
         write (*,1200)  nb_ch_data
         if (jlist)   then 
            write (lun_lst,1200)  nb_ch_data
 1200    format(' *** next_block: too long data input, nbyte=',i12)
            write (*,'('' *** block#, itag, length='',i7,i5,i10)')
     +          nblock_in+1,itag,nb_ch_data
         endif
         iend = -2
         go to 999
      endif
c
      do  i = 1, nb_ch_data
cc        read (lun_in,rec=nbyte_in+1,iostat=ios)  byte_in
        call read_next_byte (nbyte_in+1,ios,byte_in)
        if (ios.ne.0)    then
           write (*,2000) ios,nbyte_in
           if (jlist) write (lun_lst,2000) ios,nbyte_in
 2000      format(' *** next_block: abnormal eof;  ios, nbyte_in=',2i10)
           iend = -1
           call wait_press_prompt ('esc')
           go to 999
        endif
        ch_data(i) = byte_in
        nbyte_in   = nbyte_in + 1
      enddo
c
  999 end
c
c______________________________________________________________________
c
      subroutine read_next_byte (inb_byte,ios,byte)
c
c   read byte# nbyte from the input file;
c   this interface to replace  'normal read' is needed
c   for direct access files with gt.1 byte record length,
c   as e.g. under VMS (minimal 4 byte)
c
c   inb_byte (inp)  - byte#  to be read
c   ios      (out)  - iostat flag:  .ne.0 =read error
c   byte     (out)  - byte read
c
c________________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist

      parameter    (mx_full_rec=4096)
      character*1  full_rec(mx_full_rec)
      character*1  byte

      save         nrec_last, full_rec

      data         nrec_last /-1/
c
      ios    = 0
      nrec   = (inb_byte - 1) / lrec_byte_in + 1
      ip_rec = mod (inb_byte-1,lrec_byte_in) + 1
      if (lrec_byte_in.gt.mx_full_rec)   go to 910
c
      if (nrec.ne.nrec_last)   then
         read (lun_in,rec=nrec,iostat=ios)(full_rec(j),j=1,lrec_byte_in)
         if (ios.eq.0)   then
            nrec_last = nrec
         else
            nrec_last = -1
         endif
      endif
      byte = full_rec(ip_rec)
c
      if (jdebug) then
cdb         write (*,'('' byte#, byte= '',i10,z4,'' nrec, ip_rec ='',
cdb     +          2i10)')   inb_byte,byte,nrec, ip_rec
cdb         write (*,'('' fullrec=''/41(5z4,5x,5z4/))')
cdb     +         (full_rec(j),j=1,lrec_byte_in)
      endif
      go to 999
c
  910 write (*,'('' *** reclength to big:'',i12)') lrec_byte_in

  999 end
c
c_______________________________________________________________________
c
      subroutine get_clock
c
c   unpack & analyze the clock records
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1

      integer            i1_2_i4_mac*4, i1_4_i4_mac*4
c
csftn      integer*1   iprint_ch_data(mx_ch_data)
csftn      equivalence (iprint_ch_data,ch_data)
c
      data nbyte_clock / 12 /
c
csftn    if (jdebug) write (*,'(1x,12z3)') (iprint_ch_data(i),i=1,12)

      do  i = 1, nb_ch_data, nbyte_clock
        ip = (i-1)*nbyte_clock + 1
        iday  = i1_2_i4_mac (ch_data(ip))
        ihour = i1_2_i4_mac (ch_data(ip+2))
        imin  = i1_2_i4_mac (ch_data(ip+4))
        isec  = i1_2_i4_mac (ch_data(ip+6))
        imus  = i1_4_i4_mac (ch_data(ip+8))
      enddo
c
      if (nb_ch_data.ne.12)   then
         print *,' ??? more than one time record, nb=',nb_ch_data
         if (jsuspect)  call wait_press_prompt ('esc')
      endif
c
ccc      if (jdebug) write (*,'('' dd/hh/mi/se/mu:'',4(i4),3x,i8)')     
ctmp
      write (*,'('' dd/hh/mi/se/mu:'',4(i4),3x,i8)')
     +      iday,ihour,imin,isec,imus
c
      end
c
c_______________________________________________________________________
c
      subroutine get_sn
c
c   unpack & analyze the supernova records
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off

      integer            i1_1_i4*4, i1_4_i4*4, i1_4_i4_mac*4
ccc      integer*4          istat_sn(2),icount8(8),ich_help4
      integer*4          ich_help4
      character          ch_sncount(12)*1, ch_help4(4)*1
      integer*4          ich_sncount(3)
      equivalence (ich_help4,ch_help4)
      equivalence (ich_sncount,ch_sncount)

      data i_00ffffff /16777215/, i_f0000000 /-268435456/,
     +     i_0000ffff /65535/   , 
c96     +     i_07ff0000 /134152192/, i_f8000000 /-134217728/, 
     +     i_000f0000 /983040/, i_01f00000 /32505856/

c3_tmp: soffw3_tmp
c3_tmp      data i_0f000000 /251658240/

c
csftn      integer*1   iprint_ch_data(mx_ch_data)
csftn      equivalence (iprint_ch_data,ch_data)
c
c96      data nbyte_sn / 18 /
c

cxxxxxxxxxx
cccccc      jdebug = .true.

      if (iflag_snmp96.eq.0)   then
         nbyte_sn = 18 
      else
         nbyte_sn = 16 
      endif

      nstruc_sn = nb_ch_data/nbyte_sn
c
      if (mod(nb_ch_data,nbyte_sn).ne.0)    then
         print *,' *** wrong sn-block length:',nb_ch_data
         call wait_press_prompt ('esc')
      endif
c
c  read all sn - structures
c
      do  i = 1, nstruc_sn
c
c  ... first unpack
c
        ip = (i-1)*nbyte_sn + 1
csftn        write (*,'(1x,18z3)') (iprint_ch_data(j),j=ip,ip+17)
cxftn        write (*,'(1x,18z3)') (ch_data(j),j=ip,ip+17)
c         3 longint with 8 * 12bit counter
        do  j = 1, 3
          ich_sncount(j) = i1_4_i4 (ch_data(ip+(j-1)*4))
        enddo
        call conv_sncount (ch_sncount,ihit_sn)
c
c  first byte mac = msb
c
        ich_help4 = i1_4_i4_mac (ch_data(ip+12))
cdb        write (*,'('' timeword='',z10)') ich_help4

        if (iflag_snmp96.eq.0)   then
           itime_sn  = iand (i_00ffffff,ich_help4)
c3_tmp: soffw3_tmp to correct bit 21..24 ( <04/22/95)
c3_tmp: for sm022 & sm024
c3_tmp          itime_hlp = ishft (iand(i_0f000000,ich_help4),-4)
c3_tmp          itime_sn  = ior   (itime_hlp,itime_sn)
c3_tmp: soffw3_tmp

           idatid_sn = ishft (iand (i_f0000000,ich_help4),-28)
           do  j = 1, 2
             istat_sn(j) = i1_1_i4 (ch_data(ip+15+j))
           enddo

        else                              !   the 1996 snmp

           itime_sn    = iand (i_0000ffff,ich_help4)
           idatid_sn   = ishft (iand (i_000f0000,ich_help4),-16)
c96   logical cam-adr:  bit 27-31;  absolute cam-station number: bit 20-25
c96           istat_sn(1) = ishft (iand (i_f8000000,ich_help4),-27)
           istat_sn(1) = ishft (iand (i_01f00000,ich_help4),-20)
           istat_sn(2) = 0

c96tmp    *************** tmp **************  logical/not camac address
c96
c96           istat_sn(1) = istat_sn(1)+17

        endif

c
        if (jdebug)    then
           write (*,
     +    '(i4,'' stat1/2/id/tim:'',2i4,i3,i9,'' ihit:'',8i5)')
     +     i,istat_sn(1),istat_sn(2),idatid_sn,itime_sn,ihit_sn
           call wait_press_prompt ('ret')
        endif
c
c  ... now get channel numbers, sub-module number
c
        do  ichan_sub = 1, 8
          call off_channel (istat_sn(1),idatid_sn,ichan_sub,ichoff)
          ichan_off(ichan_sub) = ichoff
          if (ichoff.le.0)   then
             write (*,
     +      '('' *** suspect chan, istat_nb,idat_id,icha, ichoff='',
     +       4i5)')  istat_sn(1),idatid_sn,ichan_sub,ichoff
             if (jsuspect)    call wait_press_prompt ('esc')

czeu  try error handling
             write (*,'('' *** skip rec. for itime_sn='',i10)')itime_sn
             go to 199
          endif
        enddo
        call off_sb_mod (istat_sn(1),idatid_sn,isb_mod_off)
c
c    modify  the sn-time accordingly ...
c
        if (iflag_highrate.gt.0)   then
           call incr_sntime     ! generate sntime in high rate mode (16/256bit)
        else
           if (iflag_snmp96.ne.0)   then
              call loop_sntime  ! watch for loops over 65535 counts for snmp96
           endif
        endif         

c
c  ... and do analysis for this structure
c
        call an_sn
c
  199   continue
      enddo
c
      end
c
c_______________________________________________________________________
c
      subroutine get_mp
c
c   unpack & analyze the monopole records
c
c   (hex-constants in decimal form, since ansii-f77 without hex-standard!!)
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1

      integer            i1_1_i4*4, i1_4_i4_mac*4
      integer*4          istat_mp(2),icount8_mp(8),ich_help4
      character          ch_mpcount(4)*1, ch_help4(4)*1
      equivalence (ich_help4,ch_help4)
c
csftn      integer*1   iprint_ch_data(mx_ch_data)
csftn      equivalence (iprint_ch_data,ch_data)
c
c96      data nbyte_mp / 10 /
      data i_00ffffff /16777215/,  i_f0000000 /-268435456/,
     +     i_07000000 /117440512/, i_f8000000 /-134217728/
c


      if (iflag_snmp96.eq.0)   then
         nbyte_mp = 10 
      else
         nbyte_mp = 8 
      endif

      nstruc_mp = nb_ch_data/nbyte_mp
c
      if (mod(nb_ch_data,nbyte_mp).ne.0)    then
         print *,' *** wrong mp-block length:',nb_ch_data
         call wait_press_prompt ('esc')
      endif
c
c  read all mp - structures ...
c
      do  i = 1, nstruc_mp
c
c  ... first unpack
c
        ip = (i-1)*nbyte_mp + 1
csftn        write (*,'(1x,18z3)') (iprint_ch_data(j),j=ip,ip+nbyte_mp-1)
cxftn        write (*,'(1x,18z3)') (ch_data(j),j=ip,ip+nbyte_mp-1)
c         1 longint with 8 * 4bit counter
        do  j = 1, 4
          ch_mpcount(j) = ch_data(ip+j-1)
        enddo
        call conv_mpcount (ch_mpcount,icount8_mp)
c


        if (iflag_snmp96.eq.0)   then
c
c  get time,data-id and station nb.   (first byte mac = msb)
c
           ich_help4 = i1_4_i4_mac (ch_data(ip+4))
cdb           write (*,'('' timeword='',z10)') ich_help4
           itime_mp  = iand (i_00ffffff,ich_help4)
           idatid_mp = ishft (iand (i_f0000000,ich_help4),-28)
c
           do  j = 1, 2
             istat_mp(j) = i1_1_i4 (ch_data(ip+8+j-1))
           enddo
c           
        else
c
c96...
c96:  only 4 byte: get time,data-id and station nb.   (first byte mac = msb)
c
           ich_help4   = i1_4_i4_mac (ch_data(ip+4))
c96x
c96x           write (*,'('' timeword_mp ='',z10)') ich_help4
           itime_mp    = iand        (i_00ffffff,ich_help4)
           idatid_mp   = ishft (iand (i_07000000,ich_help4),-24)
           istat_mp(1) = ishft (iand (i_f8000000,ich_help4),-27)
           istat_mp(2) = 0
cprelim
c  very crude:   logical nb. ---> camac statnb.  (setup spole96: 0==slot12)
           istat_mp(1) = 12 + istat_mp(1)
c
        endif 
c
        if (jdebug) write (*,
     +  '(i4,'' stat1/2/id/tim:'',2i4,i3,i9,'' icou:'',8i3)')
     +    i,istat_mp(1),istat_mp(2),idatid_mp,itime_mp,icount8_mp
        if (jdebug) call wait_press_prompt ('ret')
c
c  ... now analyze
c
        call an_mp (istat_mp(1),idatid_mp,itime_mp,icount8_mp)
c
      enddo
c
      end
c
c_______________________________________________________________________
c
      subroutine get_grb_111
c
c   unpack & analyze the grb records
c     (only .ge.1996)
c
c   (hex-constants in decimal form, since ansii-f77 without hex-standard!!)
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1

      integer            i1_1_i4*4, i1_4_i4_mac*4
      integer*4          istat_mp(2),icount8_mp(8),ich_help4
      character          ch_mpcount(4)*1, ch_help4(4)*1
      equivalence (ich_help4,ch_help4)
c
csftn      integer*1   iprint_ch_data(mx_ch_data)
csftn      equivalence (iprint_ch_data,ch_data)
c
c96      data nbyte_mp / 10 /
      data i_00ffffff /16777215/,  i_f0000000 /-268435456/,
     +     i_07000000 /117440512/, i_f8000000 /-134217728/
c


      if (iflag_snmp96.eq.0)   then
         write (*,'('' *** grb not for 1995*** '')')
         if (jlist) write (lun_lst,'('' *** grb not for 1995*** '')')
         go to 999
      endif


            
      if (iflag_snmp96.eq.0)   then
         nbyte_mp = 10 
      else
         nbyte_mp = 8 
      endif

      nstruc_mp = nb_ch_data/nbyte_mp
c
      if (mod(nb_ch_data,nbyte_mp).ne.0)    then
         print *,' *** wrong mp-block length:',nb_ch_data
         call wait_press_prompt ('esc')
      endif
c
c  read all mp - structures ...
c
      do  i = 1, nstruc_mp
c
c  ... first unpack
c
        ip = (i-1)*nbyte_mp + 1
csftn        write (*,'(1x,18z3)') (iprint_ch_data(j),j=ip,ip+nbyte_mp-1)
cxftn        write (*,'(1x,18z3)') (ch_data(j),j=ip,ip+nbyte_mp-1)
c         1 longint with 8 * 4bit counter
        do  j = 1, 4
          ch_mpcount(j) = ch_data(ip+j-1)
        enddo
        call conv_mpcount (ch_mpcount,icount8_mp)
c


        if (iflag_snmp96.eq.0)   then
c
c  get time,data-id and station nb.   (first byte mac = msb)
c
           ich_help4 = i1_4_i4_mac (ch_data(ip+4))
cdb           write (*,'('' timeword='',z10)') ich_help4
           itime_mp  = iand (i_00ffffff,ich_help4)
           idatid_mp = ishft (iand (i_f0000000,ich_help4),-28)
c
           do  j = 1, 2
             istat_mp(j) = i1_1_i4 (ch_data(ip+8+j-1))
           enddo
c           
        else
c
c96...
c96:  only 4 byte: get time,data-id and station nb.   (first byte mac = msb)
c
           ich_help4   = i1_4_i4_mac (ch_data(ip+4))
c96x
c96x           write (*,'('' timeword_mp ='',z10)') ich_help4
           itime_mp    = iand        (i_00ffffff,ich_help4)
           idatid_mp   = ishft (iand (i_07000000,ich_help4),-24)
           istat_mp(1) = ishft (iand (i_f8000000,ich_help4),-27)
           istat_mp(2) = 0
cprelim
c  very crude:   logical nb. ---> camac statnb.  (setup spole96: 0==slot12)
           istat_mp(1) = 12 + istat_mp(1)
c
        endif 
c
        if (jdebug) write (*,
     +  '(i4,'' stat1/2/id/tim:'',2i4,i3,i9,'' icou:'',8i3)')
     +    i,istat_mp(1),istat_mp(2),idatid_mp,itime_mp,icount8_mp
        if (jdebug) call wait_press_prompt ('ret')
c
c  ... now analyze
c
        call an_mp (istat_mp(1),idatid_mp,itime_mp,icount8_mp)
c
      enddo
c
  999 end
c
c_______________________________________________________________________
c
      subroutine get_fifodump
c
c   fif-dump record (1996)
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1
c
c
      if (itag.eq.14)        then                          ! FIFO full
         write (*,      
     +     '('' FIFO full dump, nbyte=''i10)') nb_ch_data
         if (jlist) write (lun_lst,
     +     '('' FIFO full dump, nbyte=''i10)') nb_ch_data

      elseif (itag.eq.15)        then                      ! FIFO corrupt
         write (*,
     +     '('' FIFO corrupt, nbyte=''i10)') nb_ch_data
         if (jlist) write (lun_lst,
     +     '('' FIFO corrupt, nbyte=''i10)') nb_ch_data
      endif
c
      end
c
c_______________________________________________________________________
c
      subroutine get_message
c
c   unpack & analyze the message records:
c
c    - file header
c    - crashs: fifo overflow, fifo corrupt
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off
c
      integer            i1_1_i4*4,i1_3_i4_mac*4,i1_4_i4*4
      integer            ihlp(4)
      data               i_000000ff / 255 /
c
c
      if (iflag_snmp96.eq.0)   then                 ! 1995

      ip       = 1
      isubtag  = i1_1_i4 (ch_data(ip))
      icammod  = i1_3_i4_mac (ch_data(ip+1))
c
      if (isubtag.eq.1)        then
         write (*,'('' ... header found'')')
      else
         if (isubtag.eq.14)   then
            write (*,
     +   '('' *** MAC: FIFO Overflow  !!!  cammod#='',i6)') icammod
            if (jlist) write (lun_lst,
     +   '('' *** MAC: FIFO Overflow  !!!  cammod#='',i6)') icammod
         elseif (isubtag.eq.15)   then
            write (*,
     +   '('' *** MAC: FIFO corrupt   !!!  cammod#='',i6)') icammod
            if (jlist) write (lun_lst,
     +   '('' *** MAC: FIFO corrupt   !!!  cammod#='',i6)') icammod
         else
            write (*,
     +   '('' *** unexpected message subtag ='',i12)') isubtag
            if (jlist) write (lun_lst,
     +   '('' *** unexpected message subtag ='',i12)') isubtag
         endif
         write (*,
     +   '(''     occured after las SN time(0.5sec), submod='',2i10)')
     +   itime_sn,isb_mod_off
         if (jlist) write (lun_lst,
     +   '(''     occured after las SN time(0.5sec), submod='',2i10)')
     +   itime_sn,isb_mod_off
         if (jsuspect.or.jdebug)  call wait_press_prompt ('esc')
      endif

      else                                              ! 1996
      
         write (*,
     +   '('' Message: nbyte='',i10)')  nb_ch_data
         if (jlist) write (lun_lst,
     +   '('' Message: nbyte='',i10)')  nb_ch_data
        
        ip    = 1
        iword = i1_4_i4 (ch_data(ip))
        do i = 1, 4
          is = (i-1)*8
ccc          ih = ishft(iword,-is)
ccc          ihlp(i) = ior (i_000000ff,ih)
          ih = ishft(255,is)
          ihlp(i) = ishft (iand(ih,iword),-is)
        enddo          
        write (*,
     +   '('' ...data1: i4, 4xI1='',i12,3x,4i6)')iword,(ihlp(j),j=1,4)
        if (jlist) write (lun_lst,
     +   '('' ...data1: i4, 4xI1='',i12,3x,4i6)')iword,(ihlp(j),j=1,4)

      endif
c
      end
c
c______________________________________________________________________
c
      subroutine conv_sncount (byte_in,int_out)
c
c   convert 3 longint (12 bytes) from mac to 8 int*4 each 12 bits significant
c    (mac:  msb=first,  dos: lsb=first)
c
c   (hex-constants in decimal form, since ansii-f77 without hex-standard!!)
c______________________________________________________________________
c
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      integer*4   int_out(8),iword_in(3)
      character   byte_in(12)*1,ch_help_in(12)*1
      equivalence (ch_help_in,iword_in)

      data i_00000fff,i_00fff000,i_ff000000
     +     /     4095,  16773120, -16777216 /
      data i_0000000f,i_0000fff0,i_0fff0000,i_f0000000
     +     /       15,     65520, 268369920,-268435456 /
      data i_000000ff,i_000fff00,i_fff00000
     +     /      255,   1048320,  -1048576 /
c
      do  i = 1, 8
        int_out(i) = 0
      enddo
c reverse bytes in each word
      do  i = 1, 3
        ip = (i-1)*4
        do  j = 1, 4
          ch_help_in(ip+5-j) = byte_in(ip+j)
        enddo
      enddo
c
cdb      write (*,'('' counwd:'',3(z10,3x))') iword_in
c
      int_out(1) = iand (i_00000fff,iword_in(1))
      int_out(2) = ishft (iand (i_00fff000,iword_in(1)),-12)
      int_out(3) = ishft (iand (i_ff000000,iword_in(1)),-24)
      int_out(3) =
     + ior (int_out(3),ishft (iand (i_0000000f,iword_in(2)),+8))
      int_out(4) = ishft (iand (i_0000fff0,iword_in(2)),-4)
      int_out(5) = ishft (iand (i_0fff0000,iword_in(2)),-16)
      int_out(6) = ishft (iand (i_f0000000,iword_in(2)),-28)
      int_out(6) =
     + ior (int_out(6),ishft (iand (i_000000ff,iword_in(3)),+4))
      int_out(7) = ishft (iand (i_000fff00,iword_in(3)),-8)
      int_out(8) = ishft (iand (i_fff00000,iword_in(3)),-20)
c
      end
c______________________________________________________________________
c
      subroutine conv_mpcount (byte_in,int_out)
c
c   convert 1 longint (4 bytes) from mac to 8 int*4 each 4 bits significant
c    (mac:  msb=first,  dos: lsb=first)
c
c   (hex-constants in decimal form, since ansii-f77 without hex-standard!!)
c______________________________________________________________________
c
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      integer*4   int_out(8),iword_in
      character   byte_in(4)*1,ch_help_in(4)*1
      equivalence (ch_help_in,iword_in)

      data i_0000000f,i_000000f0,i_00000f00,
     +     i_0000f000,i_000f0000,i_00f00000,
     +     i_0f000000,i_f0000000
     +    /        15,       240,      3840,
     +          61440,    983040,  15728640,
     +      251658240,-268435456               /

c
      do  i = 1, 8
        int_out(i) = 0
      enddo
c reverse bytes in each word
cc      do  j = 1, 4
cc        ch_help_in(5-j) = byte_in(j)
cc      enddo
      iword_in = i1_4_i4_mac (byte_in)
c
cdb      write (*,'('' counwd:'',z10)') iword_in
c
      int_out(1) = iand (i_0000000f,iword_in)
      int_out(2) = ishft (iand (i_000000f0,iword_in),-4)
      int_out(3) = ishft (iand (i_00000f00,iword_in),-8)
      int_out(4) = ishft (iand (i_0000f000,iword_in),-12)
      int_out(5) = ishft (iand (i_000f0000,iword_in),-16)
      int_out(6) = ishft (iand (i_00f00000,iword_in),-20)
      int_out(7) = ishft (iand (i_0f000000,iword_in),-24)
      int_out(8) = ishft (iand (i_f0000000,iword_in),-28)
c
      end
c
c_______________________________________________________________________
c
      subroutine an_block
c
c   analyze/ histogram the next current block
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
      parameter          (mx_ch_data=128000)
      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
      character          ch_data*1
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
c
      integer            i1_1_i4*4
c
      if (j_tag)   then
         if (itag.ne.30)  then	
            call hfill (ih_tag,float(itag),0.,1.)
         else
c              don't count header (only 1st file)   
            isubtag  = i1_1_i4 (ch_data(1))
            if (isubtag.ne.1) then
               call hfill (ih_tag,float(itag),0.,1.)
            endif
         endif
      endif
c
      end
c_______________________________________________________________________
c
      subroutine an_sn
c
c sn: steering for all sn-data- and "SN" related analysis
c
c   all you need is in    common /sn_struct/ :
c
c
c    istat_sn(2)   (inp) - (1)=camac station nb. 1...22, (2)=dummy (??)
c    idatid_sn     (inp) - data-id (6/7 & 2/3 for chan1..8/9..16 for mon & sn)
c    itime_sn      (inp) - sn-time
c    ihit_sn(8)    (inp) - counts for sub_chans 1...8
c    ichan_off(8)  (inp) - the off-line numbers for sub_chans 1...8
c    isb_mod_off   (inp) - the off-line number for current sub-module
c
c
c    note:  -first sn-record (per submod) is dummy and has to be skipped !!
c            all sn-times are lowered by 1 !!!
c
c           -with analysis in periods for long files: common offset the sn_times
c            to starting value (-offs_save ticks)
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off
#include "setup.inc"
c
      integer*4   itime_offset, i_first, i_very_first(mx_nb_sbm)
      save        itime_offset, i_first, i_very_first
csetup
      data i_first /0/, i_very_first/ mx_nb_sbm*0 /

c96zz      data ishft_offset / 100 /
      data ishft_offset / 0 /                        !  offset = 0 
c
c    ... ignore the first and reset  itime_sn !!!!
c
      if (i_very_first(isb_mod_off).eq.0)   then
         i_very_first(isb_mod_off) = 1
czeu
         write (*,'('' isb_mod_off, first sn-time ='',i4,i10)') 
     +      isb_mod_off,itime_sn
         if (jlist)
     +   write (lun_lst,'('' isb_mod_off, first sn-time ='',i4,i10)') 
     +      isb_mod_off,itime_sn
     
         if (i_first.eq.0)   then
            i_first      = 1
            itime_offset = itime_sn - ishft_offset
            if (itime_sn.le.1)   itime_offset = 1
            if (itime_offset.le.0)   then
               write (*,'('' *** itime_offset.lt.0 ='',i10)')
     +         itime_offset
               if (jlist)  write (lun_lst,
     +                  '('' *** itime_offset.lt.0 ='',i10)')
     +         itime_offset
               itime_offset = 1
            endif
            write (*,
     +      '('' ... offset with isubmod, itime_offset, shift='',3i10)')
     +      isb_mod_off,itime_offset,ishft_offset
            if (jlist)  write (lun_lst,
     +      '('' ... offset with isubmod, itime_offset, shift='',3i10)')
     +      isb_mod_off,itime_offset,ishft_offset
         endif
         go to 999
      endif
c
ccc      itime_sn = itime_sn - 1
      itime_sn = itime_sn - itime_offset
c
      call an_sn_prim
      call an_sn_rate
      call an_sn_arr_rate

  999 end
c
c_______________________________________________________________________
c
      subroutine an_sn_prim
c
c sn: analyze "primary" data - nhit, times, time-diff
c
c   all you need is in    common /sn_struct/
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
#include  "rates.inc"
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off
#include "setup.inc"      
c
c
c96   max nb sub_moules = 23*2 !
c96 in setup.inc      parameter (mx_nb_sbm=46)

      integer*4   i_first(mx_nb_sbm), i_time_last(mx_nb_sbm)
      save        i_first,i_time_last
      save        ido_corr,ifirst_tmp
csetup
      data i_first, i_time_last / mx_nb_sbm*0, mx_nb_sbm*0 /
ctmp
      data ido_corr /0/, ifirst_tmp /0/
c
c
c   some special correlation histos ....
c
      if (ido_corr.ne.0 .and. ifirst_tmp.eq.0)   then
         ifirst_tmp = 1
c96tmp
         print *,'*** you should never reach this point ***'
         print *,'    ido_corr,ifirst_tmp=',ido_corr,ifirst_tmp
         read *,idum
         call hbook2 (900012,'nhit ch1 vs ch2, br2',1048,0.,4096.,
     +                1048,0.,4096.,4000.)
         call hbook2 (900034,'nhit ch3 vs ch4, br2',1048,0.,4096.,
     +                1048,0.,4096.,4000.)
         call hbook1 (900112,'nhit ch1+ch2, br2',4096,0.,4096.,0.)
         call hidopt (900112,'stat')
         call hbook1 (900134,'nhit ch3+ch4, br2',4096,0.,4096.,0.)
         call hidopt (900134,'stat')
      endif
c
c
c  ... nhit all sub-channels
c
      if (j_sn_cou)   then
         do  i = 1, 8
           ich  = ichan_off(i)
           ihit = ihit_sn(i)
           xhit = ihit
           call hfill (ih_sn_cou_cha+ich,xhit,0.,1.)
           ih   = ih_sn_cou_cha + 2000 + (ich/1000)*1000
           call hfill (ih,xhit,0.,1.)
         enddo
      endif
c
ctmp
c
      if (ido_corr.ne.0 .and. isb_mod_off.eq.11)   then
         nh1 = -1
         nh2 = -1
         nh3 = -1
         nh4 = -1
         do  i = 1, 8
           ich = ichan_off(i)
           if (ich.eq.1001) xnh1 = ihit_sn(i)
           if (ich.eq.1002) xnh2 = ihit_sn(i)
           if (ich.eq.1003) xnh3 = ihit_sn(i)
           if (ich.eq.1004) xnh4 = ihit_sn(i)
         enddo
         call hfill (900012,xnh2,xnh1,1.)
         call hfill (900034,xnh4,xnh3,1.)
         call hfill (900112,xnh1+xnh2,0.,1.)
         call hfill (900134,xnh3+xnh4,0.,1.)
      endif
c
c  ... times (in 0.5 sec units) for all & sb_mod
c
      if (j_sn_time)   then
         xitime = float (itime_sn)
         call hfill (ih_sn_time,xitime,0.,1.)
         if (isb_mod_off.gt.0) then
            call hfill (ih_sn_time+isb_mod_off,xitime,0.,1.)
         endif
      endif
c
c  ... time_diff for sb_mod
c
      if (j_sn_tdiff)   then
         if (isb_mod_off.gt.0) then
            if (i_first(isb_mod_off).eq.0) then
               i_first(isb_mod_off)     = 1
               i_time_last(isb_mod_off) = itime_sn
            else
               itime_diff     = itime_sn - i_time_last(isb_mod_off)
               i_time_last(isb_mod_off) = itime_sn
               call hfill
     +         (ih_sn_tdiff+isb_mod_off,float(itime_diff),0.,1.)
            endif
         endif
      endif
c
      end
c
c_______________________________________________________________________
c
      subroutine an_sn_rate
c
c sn: do rates for all pmts & summing
c
c     bin-width will be rounded to 0.5secs
c
c
c   all you need is in    common /sn_struct/
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
#include "setup.inc"
#include "rates.inc"
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off
c
      save        ifirst_rate,ifirst_err_rate
csetup
      data ifirst_rate, ifirst_err_rate / 0, 0 /
c
c
      if (.not.j_sn_rate)   go to  999
c
c  ...  nhit-sum per time interval --> rates
c
      if (ifirst_rate.eq.0)   then
         ifirst_rate = 1
         mx_timebin_rate = mx_timebin
c             set intervalnb. in 0.5 secs and redefine timebin_rate
         isnbin_rate = timebin_rate / 0.5
         if (isnbin_rate.lt.1)   isnbin_rate = 1
         timebin_rate = isnbin_rate * 0.5
         write (*,
     +    '('' ... chan-rates will be calculated for timebin(sec) =''
     +    ,f10.1)')  timebin_rate
cdb         call wait_press_prompt ('ret')
      endif
c
      it_bin = (itime_sn-1)/isnbin_rate + 1
      if (it_bin.lt.1)   it_bin = 1
c
      if (it_bin.gt.mx_timebin_rate)   then
         if (ifirst_err_rate.eq.0)   then
            ifirst_err_rate = 1
            write (*,
     +    '('' *** too many time_bins requested for rate vs time'')')
            if (jlist)  write (lun_lst,
     +    '('' *** too many time_bins requested for rate vs time'')')
cc            write (*,
cc     +    '(''     please select larger bin-width, current=''
cc     +      ,f5.1,'' secs with max '',i8,'' bins'')')
cc     +      timebin_rate,mx_timebin_rate
cc            write (*,'(''   please note, all times after '',f8.1
cc     +      ,'' secs will be neglected for rates'')')
cc     +      it_bin*timebin_rate
         if (.not.jwinter)  call wait_press_prompt ('esc')
         endif
      else
         do  i = 1, 8
           ich  = ichan_off(i)
           ihit = ihit_sn(i)
c   selected analysis           
           if (ichan_useana_inv(ich).le.0)   go to 200
           ic_list = ichan_order_inv(ich)
           nhit_old = nhit_rate(it_bin,ic_list)
           nhit_new = nhit_old + ihit
           if (nhit_old.eq.-100)  nhit_new = ihit
           nhit_rate(it_bin,ic_list)       = nhit_new
           ibin_last_rate(ic_list)         = it_bin
  200    enddo
      endif
c
  999 end
c
c_______________________________________________________________________
c
      subroutine an_sn_arr_rate
c
c sn: do rates & nhit for full array (all & "good")
c
c     bin-width: default like chan-rates & 0.5sec, 10sec and 100sec
c    
c          (split in separate vec. to save memory)
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
#include "setup.inc"
#include "rates.inc"
#include "rates_arr.inc"

      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off
c
      save        ifirst_rate,ifirst_err_rate
csetup
      data ifirst_arr_rate, ifirst_rate, ifirst_err_rate /0, 0, 0/
c
c   (move this to B.D.)
      data isnbin1, isnbin2, isnbin3 / 1, 20, 200 /
c  winter-version
ccc      data isnbin1, isnbin2, isnbin3 / 2, 20, 200 /
ccc      data mxtbin1, mxtbin2, mxtbin3 / 200000, 10000, 1000 /
c
c
      if (.not.j_sn_arr_rate)   go to  999
c
c       initialize only, if not channel rates
c
      if (ifirst_arr_rate.eq.0)   then
         ifirst_arr_rate = 1
         mx_timebin_arr_rate = mx_timebin
         timebin_arr_rate(1) = isnbin1 * 0.5
         timebin_arr_rate(2) = isnbin2 * 0.5
         timebin_arr_rate(3) = isnbin3 * 0.5
      endif
c
      if (j_sn_rate)   go to   100
c
      if (ifirst_rate.eq.0)   then
         ifirst_rate = 1
         mx_timebin_rate = mx_timebin
c             set intervalnb. in 0.5 secs and redefine timebin_rate
         isnbin_rate = timebin_rate / 0.5
         if (isnbin_rate.lt.1)   isnbin_rate = 1
         timebin_rate = isnbin_rate * 0.5
c98         write (*,
c98     +    '('' ... rates will be calculated for timebin, ibin =''
c98     +    ,f10.1,i5)')  timebin_rate, isnbin_rate
c98         call wait_press_prompt ('ret')
      endif
c
  100 it_bin = (itime_sn-1)/isnbin_rate + 1
      if (it_bin.lt.1)   it_bin = 1
ccc      it_bin1 = itime_sn
      it_bin1 = (itime_sn-1)/isnbin1 + 1
      it_bin2 = (itime_sn-1)/isnbin2 + 1
      it_bin3 = (itime_sn-1)/isnbin3 + 1
c
      if (it_bin.gt.mx_timebin_rate.or.it_bin1.gt.mx_timebin1_arr
     +   .or.it_bin2.gt.mx_timebin2_arr
     +   .or.it_bin3.gt.mx_timebin3_arr)           then
          if (ifirst_err_rate.le.100)   then
             ifirst_err_rate = ifirst_err_rate + 1
             write (*,
     +    '('' *** error an_sn_arr: it_bin,it_bin1,it_bin2,it_bin3'',
     +     4i8)') it_bin,it_bin1,it_bin2,it_bin3
             if (jlist) write (lun_lst,
     +    '('' *** error an_sn_arr: it_bin,it_bin1,it_bin2,it_bin3'',
     +     4i8)') it_bin,it_bin1,it_bin2,it_bin3
         if (.not.jwinter)  call wait_press_prompt ('esc')
         endif
      else
         do  i = 1, 8
           ich  = ichan_off(i)
           ihit = ihit_sn(i)
c   selected analysis           
           if (ichan_useana_inv(ich).le.0)   go to 200
           iqua = ichan_qual_inv(ich)
c
c   only good channels for array-sum etc.
c
           if (iqua.le.0)    go to   200
c
           ibranch = 1
           if (ich.gt.1000) ibranch = 2
c                 (all intervals seperately to save array-memory)
           nhit_old = nhit_arr_rate(it_bin,ibranch)
           nhit_new = nhit_old + ihit
           if (nhit_old.eq.-100) nhit_new = ihit
           nhit_arr_rate(it_bin,ibranch)  = nhit_new
           ibin_last_arr_rate = it_bin
c
           nhit_old = nhit_arr1_rate(it_bin1,ibranch)
           nhit_new = nhit_old + ihit
           if (nhit_old.eq.-100)  nhit_new = ihit
           nhit_arr1_rate(it_bin1,ibranch) = nhit_new
           ibin_last_arr123_rate(1) = it_bin1
c
           nhit_old = nhit_arr2_rate(it_bin2,ibranch)
           nhit_new = nhit_old + ihit
           if (nhit_old.eq.-100) nhit_new  = ihit
           nhit_arr2_rate(it_bin2,ibranch) = nhit_new
           ibin_last_arr123_rate(2) = it_bin2
c
           nhit_old = nhit_arr3_rate(it_bin3,ibranch)
           nhit_new = nhit_old + ihit
           if (nhit_old.eq.-100) nhit_new  = ihit
           nhit_arr3_rate(it_bin3,ibranch) = nhit_new
           ibin_last_arr123_rate(3) = it_bin3
  200    enddo
      endif
c
  999 end
c
c_______________________________________________________________________
c
      subroutine incr_sntime
c
c  for operation mode "high rate" (16/256 shifts) simulate the missing sn-time,
c  by incrementing the sn_time per sub-module
c     (i.e. assuming strict time-order in the data flow per sub-module)
c
c_______________________________________________________________________
c

      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c96      parameter          (mx_ch_data=10000)
c96      parameter          (mx_ch_data=128000)
c96      common /cur_block/ itag,nb_ch_data,ch_data(mx_ch_data)
c96      character          ch_data*1

      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off

#include "setup.inc"

c96      parameter (mx_sbmod=42)
c96      integer itime_sn_art(mx_sbmod)
      integer itime_sn_art(mx_nb_sbm)
      save    itime_sn_art, ifirst

      data ifirst /0/
c96      data  itime_sn_art / mx_sbmod*-1 /
      data  itime_sn_art / mx_nb_sbm*-1 /


      if (ifirst.eq.0)   then
         ifirst = 1
c96tmp
         write (*,
     +    '(''!!!!!  be aware, you are using artificial Sn-time !!!'')')
         write (*,'(''... return to continue..'')')
         call wait_press('ret')
      endif


      itime_sn = 0
      if (isb_mod_off.le.0.or.isb_mod_off.gt.mx_nb_sbm)   then
         write (*,'('' wrong isb_mod_off = '',i10)')  isb_mod_off
         go to 900            
      else

ccc         if (itime_sn_art(isb_mod_off).eq.-1) 
ccc     +              print *,'-1 for isbmod=', isb_mod_off
         itime_sn = itime_sn_art(isb_mod_off) + 1          
         itime_sn_art(isb_mod_off) = itime_sn 
      endif   
c
      if (jdebug)   then
         write (*,
     +   '('' incr_sntime:  isub_module, itime_sn='',2i10)')
     +   isb_mod_off,itime_sn
      endif
c
  900 continue
      end
c
c_______________________________________________________________________
c
      subroutine loop_sntime
c
c  watch for the submodules sn-time looping over 16bit 
c            (for 1996 only)
c
c  itime_sn (/sn_struct/)  -  will be set to it's  "global" value
c  itime_sn_loop           -  will be updated
c
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      common /sn_struct/ istat_sn(2),idatid_sn,itime_sn,ihit_sn(8),
     +                   ichan_off(8),isb_mod_off

#include "setup.inc"

      integer itime_sn_loop(mx_nb_sbm),itime_sn_last_orig(mx_nb_sbm)
      save    itime_sn_loop,itime_sn_last_orig, ifirst

      data  itime_sn_loop      / mx_nb_sbm*0 /,
     +      itime_sn_last_orig / mx_nb_sbm*-1 /
      data  iloop_offset  / 65535 /
      data  ifirst  / 0 /
      data  ierr0_mx / 1000 /              ! max error print  
  


      if (ifirst.eq.0)   then
         ifirst = 1
c96tmp
         ip = 5
         do i = 1, mx_nb_sbm, ip
           il = i
           iu = min((il+ip-1), mx_nb_sbm)           
cdb           if (jlist.and.i.eq.1) write (lun_lst,
cdb     +       '('' loop_sntime values: '')')
cdb           write (*,
cdb     +       '(''  sb_mod '',i3,'' -'',i3,'' :'',5i10)')  
cdb     +       il,iu,(itime_sn_loop(j),j=il,iu)     
cdb           if (jlist) write (lun_lst,
cdb     +       '(''  sb_mod '',i3,'' -'',i3,'' :'',5i10)')  
cdb     +       il,iu,(itime_sn_loop(j),j=il,iu)     
         enddo
      endif


      if (isb_mod_off.le.0.or.isb_mod_off.gt.mx_nb_sbm)   then    !just check
         write (*,'('' wrong isb_mod_off = '',i10)') isb_mod_off
         if (jlist)   write (lun_lst,
     +            '('' wrong isb_mod_off = '',i10)') isb_mod_off
         go to 900            
      endif


      it_last = itime_sn_last_orig(isb_mod_off)

c
c  debugging ...
c

      if (itime_sn.ne.(it_last+1)                     ! check runstart/loop
     +   .and. it_last.ne.-1.and.it_last.ne.iloop_offset)   then   
         ierr0 = ierr0 + 1
         if (ierr0.lt.ierr0_mx)   then
            write (*,
     +      '(''*** loop_sntime error:  last, curr time, isb_mod='',
     +      2i12,i5)') it_last,itime_sn,isb_mod_off
            if (jlist) write (lun_lst,
     +      '(''*** loop_sntime error:  last, curr time, isb_mod='',
     +      2i12,i5)') it_last,itime_sn,isb_mod_off
         elseif (ierr0.eq.ierr0_mx)   then
         write (*,'('' *** loop_sntime stop debug ********''/60(1h*))')
            if (jlist) write 
     +   (lun_lst,'('' *** loop_sntime stop debug ********''/60(1h*))')
         endif
      endif

c  tag the offset case ...  (allow for missing ioffset-value !)

      if (itime_sn.lt.it_last.and.
     +   (itime_sn.lt.5.or.it_last.gt.(iloop_offset-5)))  then          !new offset

         itime_sn_loop(isb_mod_off) = 
     +               itime_sn_loop(isb_mod_off) + iloop_offset + 1      !offset = 65536

         write (*,
     +    '('' loop_sntime updated: sb_module, itime_sn, loop='',3i10)') 
     +     isb_mod_off,itime_sn,itime_sn_loop(isb_mod_off)           
         if (jlist)  write (lun_lst,
     +    '('' loop_sntime updated: sb_module, itime_sn, loop='',3i10)')
     +     isb_mod_off,itime_sn,itime_sn_loop(isb_mod_off)           


c should go (see above)
         if (itime_sn.ne.0)  then                  !check if was sn_time=0 
            write (*,
     +      '('' *** loop_sntime at sn_time, last_sn_time='',2i15)') 
     +      itime_sn,it_last
            if (jlist) write (lun_lst,
     +      '('' *** loop_sntime at sn_time, last_sn_time='',2i15)') 
     +      itime_sn,it_last
         endif
      endif      
    
      itime_sn_last_orig(isb_mod_off) = itime_sn       !store the 16 bit original
      itime_sn = itime_sn + itime_sn_loop(isb_mod_off) !add loop offset


      if (jdebug)   then
         write (*,
     +   '('' loop_sntime:  isub_module, itime_sn='',2i10)')
     +   isb_mod_off,itime_sn
      endif
c
  900 continue
      end
c
c_______________________________________________________________________
c
      subroutine an_mp
     +          (istat_nb,idat_id,itime,icount_sub8)
c
c mp: hbook -fillings for all channels for this sub_module
c
c    istat_nb   (inp) - camac station nb. 1...22
c    idat_id    (inp) - data-id (6/7 & 2/3 for chan1..8/9..16 for mon & sn)
c    icount_sub8(inp) - counts for sub_channb. 1...8
c
c
c    note:   first mp-records (per submod) is dummy and has to be skipped !!
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
#include "setup.inc"
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
c      
      integer*4   icount_sub8(8)
      integer*4   i_first(mx_nb_sbm), i_time_last(mx_nb_sbm)
      save        i_first,i_time_last
      integer*4   i_very_first(mx_nb_sbm)
      save        i_very_first
csetup
      data i_first, i_time_last / mx_nb_sbm*0, mx_nb_sbm*0 /
      data i_very_first/ mx_nb_sbm*0 /
c
c
      if (.not.j_mp_prim)   go to    999
c
c    ... ignore the first  !!!!
c
      call off_sb_mod (istat_nb,idat_id,isb_mod_off)
      if (i_very_first(isb_mod_off).eq.0)   then
         i_very_first(isb_mod_off) = 1
         go to 999
      endif
c
      do  ichan_sub = 1, 8
        call off_channel (istat_nb,idat_id,ichan_sub,ichan_off)
        ncou = icount_sub8(ichan_sub)
        ih = ih_mp_cou_cha + ichan_off
        call hfill (ih,float(ncou),0.,1.)
      enddo
c
c  ... times
c
cccabove      call off_sb_mod (istat_nb,idat_id,isb_mod_off)
      xitime = float (itime)
      call hfill (ih_mp_time,xitime,0.,1.)
      if (isb_mod_off.gt.0) then
         call hfill (ih_mp_time+isb_mod_off,xitime,0.,1.)
      endif
c
c  ... time_diff
c
      if (isb_mod_off.gt.0) then
         if (i_first(isb_mod_off).eq.0) then
            i_first(isb_mod_off)     = 1
            i_time_last(isb_mod_off) = itime
         else
            itime_diff               = itime - i_time_last(isb_mod_off)
            i_time_last(isb_mod_off) = itime
            call hfill (ih_mp_tdiff+isb_mod_off,float(itime_diff),0.,1.)
         endif
      endif
c
  999 end
c_______________________________________________________________________
c
      subroutine fin_rates
c
c    final calculation of rates
c
c       - ignore last interval, it might be not completed (fits...)
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
#include "setup.inc"
#include "rates.inc"
#include "rates_arr.inc"

      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
c
      real        rate(mx_timebin1_arr),er_rate(mx_timebin1_arr)
ccc     +           , e_avnh(50000)
      character   title*70,ch4*4,ch6*6,ch_AB(2)*1
ccc      data        mx_eavnh /50000/
      data        ch_AB / 'B', 'A' /
c
c
      if (.not.j_sn_rate)    go to   300
c
c
      do  i = 1, nchan_order
        ichan = ichan_order(i)
c   selected analysis           
        if (ichan_useana_inv(ichan).le.0)   go to 200
c
        if (ibin_last_rate(i).gt.0)   then
           nb = ibin_last_rate(i) - 1
           if (nb.gt.mx_timebin1_arr)   then
              write (*,
     +     '('' *** fin_rates: long chan-rate vector ??? nbin, ichan='',
czeu     +     '('' *** fin_rates: local array too short - nbin, ichan='',
     +        2i10)')  nb, ichan
              if (jlist)  write (lun_lst,
     +     '('' *** fin_rates: long chan-rate vector ??? nbin, ichan='',
     +        2i10)')  nb, ichan
czeu              go to     300
           endif
           ih_nhit = 6000000 + ichan
           write (ch4,'(i4)')    ichan
           write (ch6,'(f6.1)')  timebin_rate
           title = 'Nhit, Chan '//ch4//', dt= '//ch6//'sec'
           call sfb (title,ip)
           if (isnbin_rate.eq.1)   then
              nx = 4096
           else
c       binning: sqrt(ibin), but: round to next 1, n*10, n*100
              xbin = sqrt (float(isnbin_rate))
              call bin_round (xbin,ibin)
ccccc              nx = 4096*ibin
ccccc              nx = 5000 / ibin
c      fix  # bins!
              nx = 4096
           endif
           xlo = 0.
           xup = 4096.*isnbin_rate
           call hbook1 (ih_nhit,title(:ip),nx,xlo,xup,0.)
           call hidopt (ih_nhit,'stat')
c
c  nhit per timebin & rates  -  for channels ......
c
           do j = 1, nb
             nhit      = nhit_rate(j,i)
c               nhit=-1 - no entry
             if (nhit.ne.-1)   then
                xnhit      = nhit
                rate(j)    = xnhit / timebin_rate
                er_rate(j) = sqrt (amax1(0.,xnhit)) / timebin_rate
                call hfill (ih_nhit,xnhit,0.,1.)
             else
                rate(j)    = -1.
                er_rate(j) = 0.
             endif
           enddo
           write (ch4,'(i4)')  ichan
           title = 'Rate vs. time, Chan'//ch4//', dt = '//ch6//'sec'
           call sfb (title,ip)
           ih = ih_rate_sn_cha + ichan
           tlo = 1.
           tup = nb*timebin_rate
           call hbook1 (ih,title(:ip),nb,tlo,tup,0.)
           call hpak   (ih,rate)
           call hpake  (ih,er_rate)
        else
           print *,' ... ?? empty rate histo for ichan=',ichan
        endif
  200 enddo
c
c  nhit per timebin & rates  -  for array ......
c
  300 if (.not.j_sn_arr_rate)   go to    999
      do  i = 1, 4
        do  jbranch = 1, 2
ccc          nchuse = 80
          ndead  = 0
          nbad   = 0
          nchuse = 0
czeu          do  k = (jbranch-1)*80+1, jbranch*80
          do  k = 1, nchan_order
            ich = ichan_order(k)
            iq  = ichan_qual_inv(ich)
            if (iq.gt.0)   then
               nchuse = nchuse + 1
            elseif (iq.eq.0)   then
               ndead = ndead + 1
            elseif (iq.lt.0)   then
               nbad = nbad + 1
            endif
          enddo
cdb          write (*,'('' ibranch, nchuse,nbad,ndead='',i3,i5,2i3)')
cdb     +          jbranch,nchuse,nbad,ndead
          if (i.eq.1)   then
             ibinlast = ibin_last_arr_rate
             timebin  = timebin_rate
             isnbin   = isnbin_rate
          else
             ibinlast = ibin_last_arr123_rate(i-1)
             timebin  = timebin_arr_rate(i-1)
             isnbin   = timebin / 0.5
          endif
          if (ibinlast.gt.0)   then
             nb = ibinlast - 1
c
c   rate & nhit (timebin) histos ,....
c
             ih_nhit = 6000000 + (jbranch+1)*1000 + (i-1)*10000
             if (nb.gt.mx_timebin1_arr)   then
                write (*,
     +     '('' *** fin_rates: local array too short - nbin, ih='',
     +          i10)')  nb, ih_nhit
                go to     999
             endif
             write (ch4,'(i4)')    jbranch
             write (ch6,'(f6.1)')  timebin
c96          title = 'Av. Nhit - Array, Branch'//ch4//', dt= '//ch6//'sec'
             title = 
     +    'Av. Nhit - Array, AM-'//ch_AB(jbranch)//', dt= '//ch6//'sec'
             call sfb (title,ip)
c    fix # bins !!!
ccc             nx = 4096
ccc             nx = 4096*isnbin
             call bin_round (sqrt(float(isnbin)),ibin)
             nx = 4096*ibin
             xlo = 0.
             xup = 4096.*isnbin
c !!
             xup = xup / 2.
             call hbook1 (ih_nhit,title(:ip),nx,xlo,xup,0.)
             call hidopt (ih_nhit,'stat')
c
             do j = 1, nb
               if (i.eq.1)   nhit = nhit_arr_rate(j,jbranch)
               if (i.eq.2)   nhit = nhit_arr1_rate(j,jbranch)
               if (i.eq.3)   nhit = nhit_arr2_rate(j,jbranch)
               if (i.eq.4)   nhit = nhit_arr3_rate(j,jbranch)
c                   nhit=-1 - no entry
               if (nhit.ne.-1)   then
                  xnhit      = nhit
                  avnhit     = xnhit / nchuse
                  rate(j)    = avnhit / timebin
                  er_rate(j) = sqrt (amax1(0.,xnhit))/(nchuse*timebin)
c             no!!!    ... gettting wrong stat. err on avnhit-entries ???!!!
                  call hfill (ih_nhit,avnhit,0.,1.)
               else
                  rate(j)    = -1.
                  er_rate(j) = 0.
               endif
             enddo
cccc  first correct errors for avnhit
ccc             if (nx.gt.mx_eavnh)  then
ccc                write (*,'('' too many hist-chans: ih,nx='',2i6)')
ccc     +                ih_nhit,nx
ccc                call wait_press_prompt ('esc')
ccc             else
ccc                do ihc = 1, nx
ccc                  x = hi(ih_nhit,ihc)
ccc                  e_avnh(ihc) = x / sqrt(float(nchuse))
ccc                enddo
ccc                call hpake (ih_nhit,e_avnh)
ccc             endif
             write (ch4,'(i4)')    jbranch
             write (ch6,'(f6.1)')  timebin
             title =
c96     +   'Rate vs. time - Array, Branch'//ch4//', dt= '//ch6//'sec'
cg77     +        'Rate vs. time - Array, AM-'//ch_AB(jbranch)//
cg77     +        ', dt= '//ch6//'sec'
     +'Rate vs. time-Arr, AM-'//ch_AB(jbranch)//',dt= '//ch6//'sec'
             call sfb (title,ip)
             ih = ih_rate_sn_cha + (jbranch+1)*1000 + (i-1)*10000
             tlo = 1.
             tup = nb*timebin
cdb      print *,' ...book ih, nb,tlo,tup=',ih,nb,tlo,tup
             call hbook1 (ih,title(:ip),nb,tlo,tup,0.)
             call hpak   (ih,rate)
             call hpake  (ih,er_rate)
          else
             print *,' ... ?? empty rate histo'
          endif
        enddo
      enddo
c
  999 end
c_______________________________________________________________________
c
      subroutine bin_round (xbin,ibinround)
c
c  round xbin up to next 1, 10, 100,
c    (keep, if =int)
c
c    xbin       (inp)
c    ibinround  (out)
c_______________________________________________________________________
c
      if (amod(xbin,1.).eq.0. .or. amod(xbin,10.).eq.0. .or.
     +    amod(xbin,100.).eq.0.)   then
         ibin = xbin
      elseif (xbin.lt.10.)   then
         ibin = (xbin+1.)
      elseif (xbin.lt.100.)   then
         ibin = int((xbin+10.)/10.)*10
      elseif (xbin.lt.1000.)   then
         ibin = int((xbin+100.)/100.)*100
      else
         ibin = sqrt (xbin)
      endif
c
      ibinround = ibin
      end
c
c_______________________________________________________________________
c
      subroutine set_off_channel
c
c   set the channel map for sr. off_channel
c     & sub_channel map for sr. off_sb_mod (preliminary)
c
c     i.e.  - read mapping file 'chmap.inp' or use default map
c           - print the table
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
#include "setup.inc"
c
      integer   itab(16)
      logical   yes
c
c
      ltmp = 33
      open (ltmp,file='chmap.inp',status='old',iostat=ios)
      if (ios.ne.0) then
         write (*,
     +    '('' ... can not find file: "chmap.inp" (channel map)'')')
         call mygetlog
     +    ('do you want to have default channel map (y/n)?$',yes)
         if (yes)  then
            go to 100
         else
            go to 900
         endif
      endif
c
      nl = 23
      do  i = 1, nl
        read (ltmp,*,iostat=ios) itab
        if (ios.ne.0)  then
           write (*,
     +     '('' *** error reading channel map for station#'',i5)') i
           go to 900
        endif
        do  j = 1, 16
          ichan_table(mod(j-1,8)+1,(j-1)/8+1,i) = itab(j)
        enddo
      enddo
      close (33)
c
  100 call set_chan_order
c
c  sub_module table (very preliminary:
c  consequtive numbering in crate, checking first channel per submod only)
c
      ncam   = 23
      isubmd = 0
      do icm = 1, ncam
        do jsb = 1, 2
          if (ichan_table(1,jsb,icm).gt.0) then
             isubmd = isubmd + 1
             isb_mod_table(jsb,icm) = isubmd
          else
             isb_mod_table(jsb,icm) = -1
          endif
        enddo
      enddo
c
c  print setup table
c

ccc      go to 999

      icuse=0
      n=1
      if (jlist) n=2
      do  i = 1, n
        l = 6
        if (i.eq.2) l=lun_lst

cc        write (*,'(10x,'' channel mapping:  camac to offline'',
cc     +       10x/10x,''__________________________________''/)')
cc        write (*,'(10x,'' offline channel numbers'',
cc     +       10x/10x,  ''_______________________''/)')
cc        write (l,'('' -- Offline Channel Numbers --''/)')
          write (l,'(//'' -- Channel Mapping: '')')
          write (l,'(  '' -- CAMAC to Offline Channel Numbers --'')')
cnonvms        write (*,'('' camac subadr  :'',1x,2(2x,8i5)/1x,100(''_''))')
cnonvms       +     (j,j=1,16)
        write (l,'('' camac subadr  :''/2(8i5)/80(''_''))//')
     +     (j,j=1,16)
        write (l,'('' '')')
        do  ist = 1, 23
          ipr = 0
          do  i1 = 1, 8
            do  i2 = 1, 2
              if (ichan_table(i1,i2,ist).ne.-1)   ipr = 1
            enddo
          enddo
cc          if (ipr.ne.0) write (*,'('' cam_st#: '',i3,2(2x,8i3))')
cc     +      ist,((ichan_table(j,k,ist),j=1,8),k=1,2)
          if (ipr.ne.0)   then
             icuse = icuse + 1
cccc            write (*,'('' camac slot'',i3,'' : '',2(2x,8i3))')
cccc     +      ist,((ichan_table(j,k,ist),j=1,8),k=1,2)
cnonvms            write (*,'('' camac slot'',i3,'':  '',2(2x,8i5))')
cnonvms     +      ist,((ichan_table(j,k,ist),j=1,8),k=1,2)
            write (l,'(i3''. module; camac slot'',i3,'': ''/2(8i5))')
     +      icuse,ist,((ichan_table(j,k,ist),j=1,8),k=1,2)
          endif
        enddo
        write (l,'(80(''_''))')
        write (l,'('' '')')
      enddo
c
cc      write (*,'(10x,'' sub module mapping:  camac to offline'',
cc     +       10x/10x,'' _____________________________________''/)')
cc      write (*,'(10x,'' offline submodule numbers'',
cc     +       10x/10x,'' _________________________''/)')

c97      go to  999
      
      write (*,'(/'' -- Offline Submodule Numbers --''/)')
      do  ist = 1, 23
        ipr = 0
        do  i = 1, 2
          if (isb_mod_table(i,ist).ne.-1)   ipr = 1
        enddo
        if (ipr.ne.0) write (*,'('' camac slot'',i3,'' : '',2i5)')
     +    ist,(isb_mod_table(j,ist),j=1,2)
      enddo
      
      go to 999
c
  900 write (*,'('' *** error while setting channel map ***'')')
      stop
c
  999 end
c_______________________________________________________________________
c
      subroutine off_channel
     +          (istat_nb,idat_id,ichan_sub,ichan_off)
c
c   find 'offline'-channel# for istat_nb,idat_id,ichan
c
c    istat_nb  (inp) - camac station nb. 1...22
c    idat_id   (inp) - 
c
c             1995:  data-id (6/7 & 2/3 for chan1..8/9..16 for mon & sn)
c             1996:  data_id 
c                         use  only bit 0:  0 = submodule 1 (ch1...8)
c                                           1 = submodule 2 (ch9..16)
c
c                      (was at beginning:hex64=d100 for subm. 1, 
c                                        hex75=d117 for subm. 2) 
c
c    ichan_sub (inp) - sub_channb. on board: 1...8 (0..7 from board)
c
c    ichan_off (out) - offline channel nb.:  1...80
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
#include "setup.inc"

      logical   btest
c
      ichan_off = -1

      if (iflag_snmp96.eq.0)    then
c
ccc         if (ichan_sub.ge.1.and.ichan_sub.le.8)   then
ccc         elseif (idat_id.eq.2.or.idat_id.eq.3)    then
ccc         elseif (idat_id.eq.6.or.idat_id.eq.7)    then
ccc         elseif (istat_nb.ge.1.and.istat_nb.le.22) then
ccc         else
ccc            print *,' *** wrong param: ich,idat_id,ista_nb',
ccc     +             ichan_sub,idat_id,istat_nb
ccc            if (jsuspect)    call wait_press_prompt ('esc')
ccc         endif
         if (ichan_sub.lt.1.or.ichan_sub.gt.8)     go to  50
         if (idat_id.ne.2.and.idat_id.ne.3.and.
     +       idat_id.ne.6.and.idat_id.ne.7)        go to  50
c96tmp         if (istat_nb.lt.1.or.istat_nb.gt.23)      go to  50
      
      else                     !   snmp96

c96         if (idat_id.ne.117.and.idat_id.ne.100)  go to 50 ! 100=64h,117=75h          
         if (istat_nb.lt.1.or.istat_nb.gt.23)      go to  50
      endif     
      go to   100

c
   50 print *,' *** wrong param: ichan_sub,idat_id,istat_nb',
     +        ichan_sub,idat_id,istat_nb
      if (jsuspect)    call wait_press_prompt ('esc')
      go to   999
c
c  normal mode
c
  100 ismd = 1
      if (btest(idat_id,0))   ismd = 2
      ichan_off = ichan_table (ichan_sub,ismd,istat_nb)
c
cdb         if (jdebug)
cdb     +    write (*,'('' ic_sub,idat_id,istat_nd='',3i4,'' off_chan=''
cdb     +   ,i4)')  ichan_sub,idat_id,istat_nb,ichan_off
c
  999 end
c_______________________________________________________________________
c
      subroutine off_sb_mod (istat_nb,idat_id,isb_mod_off)
c
c   find 'offline'-sub_module# for   istat_nb,idat_id
c
c    imode     (inp)   - 1 = find chan# (normal), 2 = print mapping table
c    istat_nb  (inp)   - camac station nb. 1...22
c    idat_id   (inp)   - 
c
c             1995:  data-id (6/7 & 2/3 for chan1..8/9..16 for mon & sn)
c             1996:  data_id (hex64=d100 for subm. 1, hex75=117 for subm. 2) 
c
c                         use  only bit 0:  0 = submodule 1 (ch1...8)
c                                           1 = submodule 2 (ch9..16)
c
c    isb_mod_off (out) - offline sub_module nb.:  1...2*nstring
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
#include "setup.inc"
c
      logical   btest
c
      isb_mod_off = -1
c
      if (iflag_snmp96.eq.0)     then               !  snmp95     
         if (idat_id.eq.2.or.idat_id.eq.3)    then
         elseif (idat_id.eq.6.or.idat_id.eq.7)    then
         elseif (istat_nb.ge.1.and.istat_nb.le.22) then
         else
            print *,' *** wrong param: idat_id,ista_nb', 
     +              idat_id,istat_nb
            if (jsuspect)    call wait_press_prompt ('esc')
         endif

      else                                          !  snmp96

c96tmp         if (idat_id.eq.117.or.idat_id.eq.100)   then 
         if (idat_id.eq.4.or.idat_id.eq.5)   then 
         elseif (istat_nb.ge.1.and.istat_nb.le.22) then
         else
            print *,' *** wrong param: idat_id,ista_nb', 
     +              idat_id,istat_nb
            if (jsuspect)    call wait_press_prompt ('esc')
         endif

      endif     


      ismd = 1
      if (btest(idat_id,0))   ismd = 2
      isb_mod     = isb_mod_table(ismd,istat_nb)
      if (isb_mod.gt.0) then
         isb_mod_off = isb_mod
      else
         write (*,'('' *** wrong sub-module: idat_id,ista_nb'',2i6)')
     +         idat_id,istat_nb
         if (jsuspect)    call wait_press_prompt ('esc')
      endif
      end
c_______________________________________________________________________
c
      subroutine set_chan_order
c
c   set the channel array ichan_order for all camac-existing
c   channels nchan_order:   ichan_order(1)       = lowest channel number,
c                                 (nchan_order)  = uppermost channel number
c
c     nchan_order     (out)  -  total nb. of channels found from camac
c     ichan_order     (out)  -  array, see above
c     ichan_order_inv (out)  -  channb. (1....1080...) --->  ipos
c
c_______________________________________________________________________
c
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist

#include "setup.inc"
c
      integer   ichan_temp(mx_ichan_order),ifl(mx_ichan_order)
c96      data      mx_ichan_order /160/, mx_ichan_order_inv /10000/
c
c
      nchan_order = 0
c
      do i = 1, 8
        do  j = 1, 2
          do  k = 1, 23
            if (ichan_table(i,j,k).ne.-1)   then
               nchan_order = nchan_order + 1
               if (nchan_order.gt.mx_ichan_order)   then
                  print *,' *** too many camac chans found, i=',
     +            nchan_order
                  stop
               endif
               ichan_temp(nchan_order) = ichan_table(i,j,k)
            endif
          enddo
        enddo
      enddo
c
      do  i = 1, nchan_order
        ifl(i) = 0
      enddo
      do  i = 1, nchan_order
        ichsm = 9999
        iposm = 0
        do  j = 1, nchan_order
          if (ifl(j).eq.0)   then
             if (ichan_temp(j).lt.ichsm)   then
                ichsm = ichan_temp(j)
                iposm = j
             endif
          endif
        enddo
        if (iposm.le.0)   then
           print *, ' *** error in set_chan_order'
           stop
        endif
        ichan_order(i) = ichsm
        ifl(iposm)     = 1
      enddo
c
      write (*,'('' nchan_order, ichan_order:'',i6/10(10i6/))')
     +      nchan_order, ichan_order
c
c  and now the inverse order....
c
      do  k = 1, nchan_order
        ichan = ichan_order(k)
        if (ichan.gt.mx_ichan_order_inv)   then
           print *,' ***  error in set_chan_order: ichan=',ichan
           stop
        endif
        icc = -1
        do  i = 1, nchan_order
          if (ichan.eq.ichan_order(i))  then
             icc = i
             go to    10
          endif
        enddo
ccc        if (icc.eq.-1)   then
ccc           print *,' *** error in ichan_order_inv, ichan=',ichan
ccc           call wait_press_prompt ('esc')
ccc           stop
ccc        endif
   10   ichan_order_inv(ichan) = icc
      enddo
c
      do  i = 1, mx_ichan_order_inv/10
        il = (i-1)*10+1
        iu = il+9
cdb        write (*,'(''ichan_order_inv:''/(i5,3x,10i5))')
cdb     +        il,(ichan_order_inv(j),j=il,iu)
      enddo
c
      end
c
c_______________________________________________________________________
c
      subroutine set_qual_channel
c
c   set the channel quality
c           - read quality file 'chqual.inp' or use default map
c           - print the table
c   relaxed: accept less input chans from file than compiled
c_______________________________________________________________________
c
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
#include "setup.inc"
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
c
      logical   yes
      character  ch_AB(2)*1
      
      data mx_qual_inv /10000/
      data ch_AB  /'B','A'/
c
c
      ltmp = 33
      open (ltmp,file='chqual.inp',status='old',iostat=ios)
      if (ios.ne.0) then
         write (*,
     +'('' ... can not find file: "chqual.inp" (chan quality map)'')')
         call mygetlog
     +    ('do you want to have default quality map (y/n)?$',yes)
         if (yes)  then
c96            do  i = 1, 160
c97            do  i = 1, mx_ichan_order   ! this may crash 
            do  i = 1, nchan_order
              ichan                 = ichan_order(i)
              ichan_qual_inv(ichan) = iqual_def(i)
            enddo
            go to 100
         else
            go to 900
         endif
      endif
c
      do  i = 1, nchan_order         !  first all chans to bad quality
        ichan                 = ichan_order(i)
        ichan_qual_inv(ichan) = 0
      enddo

c96      nl = 160
      nl = mx_ichan_order
      do  i = 1, nl
        read (ltmp,*,iostat=ios) ichan, iqual
        if (ios.eq.-1) then
           write 
     +     (*,'(''  number of channels in chqual.inp is='',i5)') i
           goto  50
        elseif (ios.ne.0)  then
           write (*,
     +     '('' *** error reading quality map line#, ios='',2i5)')i,ios
           go to 900
        elseif (ichan.le.0 .or. ichan.gt.mx_qual_inv .or.
     +     iqual.lt.-1 .or. iqual.gt.1)   then
           write (*,
     +     '('' *** error reading quality map for ichan,iqual='',2i5)')
     +     ichan,iqual
           go to 900
        endif
        ichan_qual_inv(ichan) = iqual
      enddo
   50 close (ltmp)
c
c  fill the 2 histos...
c   
czeu  100 do i = 1, 160
  100 do i = 1, nchan_order
        ichan = ichan_order(i)
        if (iflag_snmp96.eq.0)   then       ! 1995
           ic    = mod (ichan,1000)
           iqual = ichan_qual_inv(ichan)
           ih = ih_qual + (i-1)/80
           call hfill (ih,float(ic),0.,float(iqual))
        else                                ! 1996
           if (ichan.gt.0 .and. ichan.lt.2000)    then     !  existing chans           
              if (ichan.lt.1000)   then      ! AMANDA-B
                 ic = ichan
                 ih = ih_qual       
              else                           ! AM-A
                 ic = mod (ichan,1000)
                 ih = ih_qual + 1 
              endif       
              iqual = ichan_qual_inv(ichan)
              call hfill (ih,float(ic),0.,float(iqual))
           endif      
        endif
      enddo
c
c  print reducued quality table
c
ccc      write (*,'('' -- Offline Channel Quality --'')')
ccc      do  i = 1, 160
ccc        ichan = ichan_order(i)
ccc        iqual = ichan_qual_inv(ichan)
ccc        if (iqual.le.0)   then
ccc           write (*,'('' chan, qual ='',2i6)') ichan, iqual
ccc        endif
ccc      enddo

c
c  print full quality table
c
cc      n=1
cc      if (jlist) n=2
cc      do  j = 1, n
cc        l = 6
cc        if (n.eq.2) l=lun_lst
        write (*,'(/'' -- Offline Channel Quality --'')')
        write (lun_lst,'(/'' -- Offline Channel Quality --'')')
          write (*,'(4x,2(10i3,5x))') (k,k=1,20)
          write (lun_lst,'(4x,2(10i3,5x))') (k,k=1,20)
        do  ib = 1, 2
c96          write (*,'(/'' ...'',i2,''. Branch:'')') ib
c96          write (lun_lst,'(/'' ...'',i2,''. Branch:'')') ib
          write (*,'(/'' .... AM-'',a1)') ch_AB(ib)
          write (lun_lst,'(/'' .... AM-'',a1)') ch_AB(ib)
          do is = 1, 4
            ilf = (is-1)*20
            i = (ib-1)*1000 + (is-1)*20
            write (*,'(i4,2(10i3,5x))')ilf,(ichan_qual_inv(i+k),k=1,20)
            write (lun_lst,
     +               '(i4,2(10i3,5x))')ilf,(ichan_qual_inv(i+k),k=1,20)
          enddo
        enddo
cc      enddo
      go to   999
c
  900 write (*,9000)
      if (jlist) write (lun_lst,9000)
 9000 format
     + (' *** set_qual_channel: error setting quality map ***')
      stop
  999 end
c
c_______________________________________________________________________
c
      subroutine set_useana_channel
c
c   set the list of channels to be used in analysis (other's are ignored,
c             will not generate index-ov for the shorted rate-arrays)
c
c           - read file 'chuse.inp' 
c           - print the table
c
c   relaxed: accept less input chans from file than compiled
c_______________________________________________________________________
c

#include "rates.inc"
      common /user/      lun_in,lun_hbk,lun_hbksat,lun_lst,
     +                   fname_hbk,fname_hbksat,name_run,
     +                   iflag_hbk,lrec_byte_in,nbyte_in,nblock_in,
     +                   iflag_highrate,iflag_snmp96
      character          fname_hbk*96,fname_hbksat*96,
     +                   name_run*96
      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
#include "setup.inc"
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
c
      character  ch_AB(2)*1
      logical   yes

c.. to common !!!(+block data)
      data mx_useana_inv /10000/
      data ch_AB  /'B','A'/
c
c

      ltmp = 33
      open (ltmp,file='chuse.inp',status='old',iostat=ios)
      if (ios.ne.0) then
         write (*,
     +'('' ... can not find file: "chuse.inp" (selection map)'')')
         call mygetlog
     +('do you want to have default: all channels selected (y/n)?$',yes)
         if (yes)  then
c96            do  i = 1, 160
            do  i = 1, nchan_order
              ichan                   = ichan_order(i)
              ichan_useana_inv(ichan) = 1
            enddo
            go to 100
         else
            go to 900
         endif
      endif
c
      do  i = 1, nchan_order          !  first all chans to non-exist 
        ichan                   = ichan_order(i)
        ichan_useana_inv(ichan) = -1
      enddo

c97xx
      print *, ' set_use_ana:    nchan_order=', nchan_order
       
c96      nl = 160
c97      nl = nchan_order
      nl = mx_ichan_order                ! stop by eof
      do  i = 1, nl
        read (ltmp,*,iostat=ios) ichan, iuse
        if (ios.eq.-1) then
           write 
     +     (*,'('' number of channels in chuse.inp is: '',i5)') i
           goto  50
        elseif (ios.ne.0)  then
           write (*,
     +     '('' *** error reading chuse map line#, ios='',i5)')i,ios
           go to 900
        elseif (ichan.le.0 .or. ichan.gt.mx_useana_inv .or.
     +     iuse.lt.-1 .or. iuse.gt.1)   then
           write (*,
     +     '('' *** error reading chuse map for ichan,iuse='',2i5)')
     +     ichan,iuse
           go to 900
        endif
        ichan_useana_inv(ichan) = iuse
        if (i.gt.mx_channel .and. iuse.gt.0)   then
           write(*,
     +  '('' *** requesting too many channels for analysis: i,mx_chan=''
     +    ,2i6)')   i,mx_channel 
           write(*,'('' *** adjust your selection map "chuse.inp"''
     +              /''     or recompile progam with larger mx_chan'')')
           go to   900 
        endif
      enddo
   50 close (ltmp)

c
c  fill the 2 histos...
c  
  100 continue 
czeu  100 do i = 1, 160
cc  100 do i = 1, nchan_order
cc        ichan = ichan_order(i)
cc        ic    = mod (ichan,1000)
cc        iqual = ichan_qual_inv(ichan)
cc        ih = ih_qual + (i-1)/80
cc        call hfill (ih,float(ic),0.,float(iqual))
cc      enddo
c
c  print reducued quality table
c
ccc      write (*,'('' -- Offline Channel Quality --'')')
ccc      do  i = 1, 160
ccc        ichan = ichan_order(i)
ccc        iqual = ichan_qual_inv(ichan)
ccc        if (iqual.le.0)   then
ccc           write (*,'('' chan, qual ='',2i6)') ichan, iqual
ccc        endif
ccc      enddo

c
c  print full quality table
c
cc      n=1
cc      if (jlist) n=2
cc      do  j = 1, n
cc        l = 6
cc        if (n.eq.2) l=lun_lst
        write (*,'('' -- Offline Channel Selection --'')')
        write (lun_lst,'('' -- Offline Channel Selection --'')')
          write (*,'(4x,2(10i3,5x))') (k,k=1,20)
          write (lun_lst,'(4x,2(10i3,5x))') (k,k=1,20)
        do  ib = 1, 2
c96          write (*,'(/'' ...'',i2,''. Branch:'')') ib
c96          write (lun_lst,'(/'' ...'',i2,''. Branch:'')') ib
          write (*,'(/'' .... AM-'',a1)')        ch_AB(ib)
          write (lun_lst,'(/'' .... AM-'',a1)')  ch_AB(ib)
          do is = 1, 4
            ilf = (is-1)*20
            i = (ib-1)*1000 + (is-1)*20
            write(*,'(i4,2(10i3,5x))')ilf,(ichan_useana_inv(i+k),k=1,20)
            write (lun_lst,
     +              '(i4,2(10i3,5x))')ilf,(ichan_useana_inv(i+k),k=1,20)
          enddo
        enddo
cc      enddo
      go to   999
c
  900 write (*,9000)
      if (jlist) write (lun_lst,9000)
 9000 format
     + (' *** set_useana_channel: error setting selection map ***')
      stop
  999 continue
  
      end
c_______________________________________________________________________
c
      integer*2 function i1_2_i2 (ibyte)
c
c   convert two Integer*1 (ibyte(1,2))  to I2
c_______________________________________________________________________
c
      integer*2   i2
cc      integer*1   ibyte(2),ib(2)
      character*1   ibyte(2),ib(2)
      equivalence (ib(1),i2)
c
      call unix_cyclic_2 (ibyte,2,ib)
cc      ib(1)   = ibyte(1)
cc      ib(2)   = ibyte(2)
      i1_2_i2 = i2
      end
c_______________________________________________________________________
c
      integer*4 function i1_1_i4 (ibyte)
c
c   convert one Integer*1 (ibyte)  to I4
c_______________________________________________________________________
c
cc      integer     ibyte*1,i_4*4,ib(4)*1
      character*1 ibyte,ib(4),ib_in(4)
      integer     i_4*4
      equivalence (ib(1),i_4)
c
      i_4      = 0
cc      ib(1)    = ibyte
      ib_in(1) = ibyte
      call unix_cyclic_4 (ib_in,1,ib)
      i1_1_i4  = i_4
      end
c_______________________________________________________________________
c
      integer*4 function i1_2_i4 (ibyte)
c
c   convert two Integer*1 (ibyte(1,2))  to I4
c_______________________________________________________________________
c
      integer*4   i_4
cc      integer*1   ibyte(2),ib(2)
      character*1   ibyte(2),ib(4),ib_in(4)
      equivalence (ib(1),i_4)
c
      i_4      = 0
      ib_in(1) = ibyte(1)
      ib_in(2) = ibyte(2)
      call unix_cyclic_4 (ib_in,2,ib)
cc      ib(1)   = ibyte(1)
cc      ib(2)   = ibyte(2)
      i1_2_i4 = i_4
      end
c_______________________________________________________________________
c
      integer*4 function i1_3_i4 (ibyte)
c
c   convert three Integer*1 (ibyte(1,2))  to I4
c   added 11/94
c_______________________________________________________________________
c
      integer*4   i_4
cc      integer*1   ibyte(2),ib(2)
      character*1   ibyte(3),ib(4),ib_in(4)
      equivalence (ib(1),i_4)
c
      i_4      = 0
      ib_in(1) = ibyte(1)
      ib_in(2) = ibyte(2)
      ib_in(3) = ibyte(3)
      call unix_cyclic_4 (ib_in,3,ib)
cc      ib(1)   = ibyte(1)
cc      ib(2)   = ibyte(2)
      i1_3_i4 = i_4
      end
c_______________________________________________________________________
c
      integer*4 function i1_4_i4 (ibyte)
c
c   convert four Integer*1(ibyte(1...4))  to  I4
c_______________________________________________________________________
c
cc      integer*1   ibyte(4),ib(4)
      character*1   ibyte(4),ib(4),ib_in(4)
      integer*4   i_4
      equivalence (ib(1),i_4)
c
cc      ib(1)   = ibyte(1)
cc      ib(2)   = ibyte(2)
cc      ib(3)   = ibyte(3)
cc      ib(4)   = ibyte(4)
      ib_in(1) = ibyte(1)
      ib_in(2) = ibyte(2)
      ib_in(3) = ibyte(3)
      ib_in(4) = ibyte(4)
      call unix_cyclic_4 (ib_in,4,ib)
      i1_4_i4 = i_4
      end
c_______________________________________________________________________
c
      integer*4 function i1_4_u4 (ibyte)
c
c   convert four Integer*1(ibyte(1...4))  to  U4
c_______________________________________________________________________
c
cc      integer*1   ibyte(4)
      character*1   ibyte(4)
      integer*4   i1_4_i4, i_4
c
      i_4 = i1_4_i4 (ibyte)
      if (i_4.lt.0)   then
         write (*,
     +    '('' *** attention; i1_4_u4 with int*4 negative='',i15)') i_4
      endif
      i1_4_u4 = i1_4_i4 (ibyte)
      end
c_______________________________________________________________________
c
      integer*4 function i1_2_i4_mac (ibyte)
c
c   convert two Integer*1 (ibyte(1,2))  to I4  for MAC-input data
c_______________________________________________________________________
c
      integer*4   i_4
cc      integer*1   ibyte(2),ib(2)
      character*1   ibyte(2),ib(4),ib_in(4)
      equivalence (ib(1),i_4)
c
      i_4      = 0
      ib_in(1) = ibyte(2)
      ib_in(2) = ibyte(1)
      call unix_cyclic_4 (ib_in,2,ib)
cc      ib(1)   = ibyte(1)
cc      ib(2)   = ibyte(2)
      i1_2_i4_mac = i_4
      end
c_______________________________________________________________________
c
      integer*4 function i1_3_i4_mac (ibyte)
c
c   convert three Integer*1 (ibyte(1,2,3))  to I4 for MAC-format (i.e.cycl.!)
c   added 11/94
c_______________________________________________________________________
c
      integer*4   i_4
cc      integer*1   ibyte(2),ib(2)
      character*1   ibyte(3),ib(4),ib_in(4)
      equivalence (ib(1),i_4)
c
      i_4      = 0
      ib_in(1) = ibyte(3)
      ib_in(2) = ibyte(2)
      ib_in(3) = ibyte(1)
      call unix_cyclic_4 (ib_in,3,ib)
cc      ib(1)   = ibyte(1)
cc      ib(2)   = ibyte(2)
      i1_3_i4_mac = i_4
      end
c_______________________________________________________________________
c
      integer*4 function i1_4_i4_mac (ibyte)
c
c   convert four Integer*1(ibyte(1...4))  to  I4  for input in MAC format
c_______________________________________________________________________
c
cc      integer*1   ibyte(4),ib(4)
      character*1   ibyte(4),ib(4),ib_in(4)
      integer*4   i_4
      equivalence (ib(1),i_4)
c
cc      ib(1)   = ibyte(1)
cc      ib(2)   = ibyte(2)
cc      ib(3)   = ibyte(3)
cc      ib(4)   = ibyte(4)
      ib_in(1) = ibyte(4)
      ib_in(2) = ibyte(3)
      ib_in(3) = ibyte(2)
      ib_in(4) = ibyte(1)
      call unix_cyclic_4 (ib_in,4,ib)
      i1_4_i4_mac = i_4
      end
c_______________________________________________________________________
c
      subroutine sfb (string,ipos)
c
c  search for first blank
c  ipos (out)  =  pointer to first blank
c_______________________________________________________________________
c
      character*(*) string
      imax=len(string)
      ipos = imax
   10 if (string(ipos:ipos).ne.' ')  go to 900
         ipos = ipos - 1
      if (ipos .eq. 0)  then
         ipos = 1
         go to 900
      endif
      go to   10
 900  return
      end
c
c_______________________________________________________________________
c
      subroutine imi_block_data
c
c
c  imitate "block data" for the  long rate-arrays:
c
c    this saves VERY MUCH compile/link time on crazy f77-compilers like on LINUX
c
c_______________________________________________________________________
c

#include "rates.inc"
#include "rates_arr.inc"

c
      parameter  (nbtimtot=mx_channel*mx_timebin)
c

c
c  ................
c  .... rates .....
c  ................
c
cDOS - compiler overflow
ccc      data nhit_rate      / nbtimtot*-100. /,
ccc     +    nhit_arr_rate  / mx_timebin*-100.,mx_timebin*-100. /
ccc      data
ccc     +    nhit_arr1_rate / mx_timebin1_arr*-100.,mx_timebin1_arr*-100./
ccc      data
ccc     +    nhit_arr2_rate / mx_timebin2_arr*-100.,mx_timebin2_arr*-100./
ccc      data
ccc     +    nhit_arr3_rate / mx_timebin3_arr*-100.,mx_timebin3_arr*-100./
ccc      data
ccc     +    ibin_last_rate / mx_channel*0 /,
ccc     +    ibin_last_arr_rate, ibin_last_arr123_rate   / 0, 3*0 /


         ndim2 = 2
         rate_init = -100.

         do  i = 1, ndim2
c96           do  j = 1, mx_timebin_arr
           do  j = 1, mx_timebin
             nhit_arr_rate(j,i) = rate_init 
           enddo
         enddo
         do  i = 1, ndim2
           do  j = 1, mx_timebin1_arr
             nhit_arr1_rate(j,i) = rate_init
           enddo
         enddo
         do  i = 1, ndim2
           do  j = 1, mx_timebin2_arr
             nhit_arr2_rate(j,i) = rate_init 
           enddo
         enddo
         do  i = 1, ndim2
           do  j = 1, mx_timebin3_arr
             nhit_arr3_rate(j,i) = rate_init 
           enddo
         enddo

      end
c
c_______________________________________________________________________
c
      block data
c
c  Fix:
c    Array Setup,
c    Camac-Channel mapping (default),
c    Quality of Channels   (default),
c    Rate-timebins (main, siehe auch an_sn_arr_rate),
c    HBOOK (id's & switches)
c
c_______________________________________________________________________
c
c
#include "setup.inc"
#include "rates.inc"
#include "rates_arr.inc"
c
      parameter  (nbtimtot=mx_channel*mx_timebin)
c
      common /hbkids/    ih_tag,ih_qual,
     +                   ih_sn_cou_cha,ih_sn_time,ih_sn_tdiff,
     +                   ih_mp_cou_cha,ih_mp_time,ih_mp_tdiff,
     +                   ih_rate_sn_cha
      common /hbkact/    jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim
      logical            jhdum,j_tag,
     +                   j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff,
     +                   j_sn_rate,j_sn_arr_rate,
     +                   j_mp_prim

      common /runset/    jdebug,jsuspect,jwinter,jlist
      logical            jdebug,jsuspect,jwinter,jlist
c
c  ...................
c  .... geometry .....
c  ...................
c
      data  nstring  / 4 /
      data  nom_str  / 20 /
      data  inbstr   / 0,1,8,9,-1, -1,-1,-1,-1,-1 /
c
c  ...............................
c  .... Camac-Channel-Mapping ....
c  ...............................
c
c  the mapping table is organized as a matrix:   1 row per camac station
c
c  8 channels per submodule, 2 submodules, max 23 boards in crate
c
c        each row for one camac station (1:23)
c        each column for every input channel per station (1...16)
c        please, set unused channels to -1
c
c        these are the default parameter, used if no file 'chmap.inp' found
c
      data  ichan_table /
c   camac module 1...13
     +     160  *-1,
     +     16  *-1,
     +     16  *-1,
     +     16  *-1,
c   camac module 14...23
     +      1, 2, 3, 4, 5, 6, 7, 8,    9,10,11,12,13,14,15,16,
     +     17,18,19,20,21,22,23,24,   25,26,27,28,29,30,31,32,
     +     33,34,35,36,37,38,39,40,   41,42,43,44,45,46,47,48,
     +     49,50,51,52,53,54,55,56,   57,58,59,60,61,62,63,64,
     +     65,66,67,68,69,70,71,72,   73,74,75,76,77,78,79,80,
     +   1001,1002,1003,1004,1005,1006,1007,1008,
     +   1009,1010,1011,1012,1013,1014,1015,1016,
     +   1021,1022,1023,1024,1025,1026,1027,1028,
     +   1029,1030,1031,1032,1033,1034,1035,1036,
     +   1041,1042,1043,1044,1045,1046,1047,1048,
     +   1049,1050,1051,1052,1053,1054,1055,1056,
     +   1061,1062,1063,1064,1065,1066,1067,1068,
     +   1069,1070,1071,1072,1073,1074,1075,1076,
     +   1017,1018,1019,1020,1037,1038,1039,1040,
     +   1057,1058,1059,1060,1077,1078,1079,1080
     +  /
c
      data  ichan_order      / mx_ichan_order*0 /
      data  ichan_order_inv  / mx_ichan_order_inv*0 /
c
c  ..................................................
c  .... Camac-Quality : 0 = dead, -1=bad, +1=good....
c  ..................................................
c
      data iqual_def /
c
cc run auto046 bad = 6, 20, 50, 72
c  branch 1pe
c96     +  1, 1, 1, 1, 1,-1, 1, 1, 1, 1,   1, 1, 1, 1, 1, 1, 1, 1, 1,-1,
c96     +  0, 1, 1, 1, 1, 1, 1, 1, 1, 1,   1, 1, 1, 0, 1, 1, 1, 0, 0, 0,
c96     +  1, 1, 1, 1, 1, 1, 1, 1, 1,-1,   1, 1, 1, 1, 1, 0, 1, 1, 1, 1,
c96     +  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,   1,-1, 1, 1, 1, 1, 1, 0, 1, 1,
c  branch 2pe
c96     +  1, 1, 1, 1, 1,-1, 1, 1, 1, 1,   1, 1, 1, 1, 1, 1, 1, 1, 1,-1,
c96     +  0, 1, 1, 1, 1, 1, 1, 1, 1, 1,   1, 1, 1, 0, 1, 1, 1, 0, 0, 0,
c96     +  1, 1, 1, 1, 1, 1, 1, 1, 1,-1,   1, 1, 1, 1, 1, 0, 1, 1, 1, 1,
c96     +  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,   1,-1, 1, 1, 1, 1, 1, 0, 1, 1
c
c  snmp1996
c       
     +     mx_ichan_order * 1
     +
     +  /
c
c  ................
c  .... rates & interval .....
c  ................
c
cDOS - compiler overflow
clinux      data nhit_rate      / nbtimtot*-100. /,
clinux     +    nhit_arr_rate  / mx_timebin*-100.,mx_timebin*-100. /
clinux      data
clinux     +    nhit_arr1_rate / mx_timebin1_arr*-100.,mx_timebin1_arr*-100./
clinux      data
clinux     +    nhit_arr2_rate / mx_timebin2_arr*-100.,mx_timebin2_arr*-100./
clinux      data
clinux     +    nhit_arr3_rate / mx_timebin3_arr*-100.,mx_timebin3_arr*-100./
c
      data
     +    ibin_last_rate / mx_channel*0 /,
     +    ibin_last_arr_rate, ibin_last_arr123_rate   / 0, 3*0 /
      data  timebin_rate / 10.0 /
c
c   ...............................
c   .... histo-id's & switches ....
c   ...............................
c
      data  j_tag /.true. /
      data  j_sn_prim,j_sn_cou,j_sn_time,j_sn_tdiff
     +     /.true.,.true.,.false.,.false./
ccc     +     /.true.,.false.,.false.,.false./
      data  j_sn_rate, j_sn_arr_rate
     +     / .true., .true. /
      data  j_mp_prim
c96win     +     / .false. /
c99     +     / .true. /
     +     / .false. /
c

      data  ih_tag, ih_qual  / 1, 10 /
      data  ih_sn_cou_cha, ih_sn_time, ih_sn_tdiff
     +     / 1 000000, 1 100000, 1 200000 /
      data  ih_mp_cou_cha, ih_mp_time, ih_mp_tdiff
     +     / 2 000000, 2 100000, 2 200000 /
      data  ih_rate_sn_cha
     +     / 5 000000 /
c
c
c
c   ...............................
c   .... runsettings           ....
c   ...............................
c
      data jwinter /.true./, jlist /.true./
ccc      data jwinter /.false./, jlist /.true./


      end

c ---------------------------------------
c -  stuff for debugging  ---------------
c ---------------------------------------
c
c
      subroutine dbg_isbmod_tab (ilevel)
c      
c
c--------------------------------------------------------------
#include "setup.inc"

      return
      print *,' isb_mod_table; debug#=',ilevel
      do i = 1, 23
        print *,' istat=',i,isb_mod_table(1,i),isb_mod_table(2,i) 
      enddo
      end

